' ****************************************************************************************
' DWebBrowserEvents2 dispatch interface
' IID = {34A715A0-6587-11D0-924A-0020AFC7AC4D}
' Microsoft documentation:
' http://msdn.microsoft.com/library/default.asp?url=/workshop/browser/webbrowser/reference/ifaces/dwebbrowserevents2/dwebbrowserevents2.asp
' ****************************************************************************************

' ****************************************************************************************
' EXCEPINFO structure
' ****************************************************************************************
Type DWebBrowserEvents2_EXCEPINFO
   wCode As Word               ' An error code describing the error.
   wReserved As Word           ' Reserved
   bstrSource As Dword         ' Source of the exception.
   bstrDescription As Dword    ' Textual description of the error.
   bstrHelpFile As Dword       ' Help file path.
   dwHelpContext As Dword      ' Help context ID.
   pvReserved As Dword         ' Reserved.
   pfnDeferredFillIn As Dword  ' Pointer to function that fills in Help and description info.
   scode As Dword              ' An error code describing the error.
End Type
' ****************************************************************************************

' ****************************************************************************************
' Returns a pointer to a specified interface on an object to which a client currently holds an
' interface pointer.
' ****************************************************************************************
Function DWebBrowserEvents2_IUnknown_QueryInterface (ByVal pthis As Dword Ptr, ByRef riid As Guid, ByRef ppvObj As Dword) As Long
   Local HRESULT As Long
   Call Dword @@pthis[0] Using DWebBrowserEvents2_IUnknown_QueryInterface(pthis, riid, ppvObj) To HRESULT
   Function = HRESULT
End Function
' ****************************************************************************************

' ****************************************************************************************
' Decrements the reference count for the calling interface on a object. If the reference count
' on the object falls to 0, the object is freed from memory.
' ****************************************************************************************
Function DWebBrowserEvents2_IUnknown_Release (ByVal pthis As Dword Ptr) As Dword
   Local DWRESULT As Dword
   Call Dword @@pthis[2] Using DWebBrowserEvents2_IUnknown_Release(pthis) To DWRESULT
   Function = DWRESULT
End Function
' ****************************************************************************************

' ****************************************************************************************
' IConnectionPointContainer::FindConnectionPoint
' Returns a pointer to the IConnectionPoint interface of a connection point for a specified IID,
' if that IID describes a supported outgoing interface.
' ****************************************************************************************
Function DWebBrowserEvents2_IConnectionPointContainer_FindConnectionPoint ( _
   ByVal pthis As Dword Ptr, ByRef riid As Guid, ByRef ppCP As Dword) As Long
   Local HRESULT As Long
   Call Dword @@pthis[4] Using DWebBrowserEvents2_IConnectionPointContainer_FindConnectionPoint(pthis, riid, ppCP) To HRESULT
   Function = HRESULT
End Function
' ****************************************************************************************

' ****************************************************************************************
' IConnectionPoint::Advise
' Establishes a connection between the connection point object and the client's sink.
' ****************************************************************************************
Function DWebBrowserEvents2_IConnectionPoint_Advise (ByVal pthis As Dword Ptr, _
   ByVal pUnkSink As Dword, ByRef pdwCookie As Dword) As Long
   Local HRESULT As Long
   Call Dword @@pthis[5] Using DWebBrowserEvents2_IConnectionPoint_Advise(pthis, pUnkSink, pdwCookie) To HRESULT
   Function = HRESULT
End Function
' ****************************************************************************************

' ****************************************************************************************
' IConnectionPoint::Unadvise
' Terminates an advisory connection previously established through IConnectionPoint_Advise.
' The dwCookie parameter identifies the connection to terminate.
' ****************************************************************************************
Function DWebBrowserEvents2_IConnectionPoint_Unadvise (ByVal pthis As Dword Ptr, ByVal dwCookie As Dword) As Long
   Local HRESULT As Long
   Call Dword @@pthis[6] Using DWebBrowserEvents2_IConnectionPoint_Unadvise(pthis, dwCookie) To HRESULT
   Function = HRESULT
End Function
' ****************************************************************************************

' ****************************************************************************************
' IDispatch virtual table
' ****************************************************************************************
Type DWebBrowserEvents2_IDispatchVtbl
   QueryInterface As Dword     ' Returns pointers to supported interfaces
   AddRef As Dword             ' Increments reference count
   Release As Dword            ' Decrements reference count
   GetTypeInfoCount As Dword   ' Retrieves the number of type descriptions
   GetTypeInfo As Dword        ' Retrieves a description of object's programmable interface
   GetIDsOfNames As Dword      ' Maps name of method or property to DispId
   Invoke As Dword             ' Calls one of the object's methods, or gets/sets one of its properties
   pVtblAddr As Dword          ' Address of the virtual table
   cRef As Dword               ' Reference counter
   pthis As Dword              ' IUnknown or IDispatch of the control that fires the events
   fNewWindow3 As Long         ' Flag - indicates that the NewWindow3 event has been fired
   ppdoc As Dword              ' Reference to the IHTMLDocument interface
   pDocCookie As Dword         ' Reference to the HTMLDocumentEvents2 interface
End Type
' ****************************************************************************************

' ****************************************************************************************
' UI4 AddRef()
' Increments the reference counter.
' ****************************************************************************************
Function DWebBrowserEvents2_AddRef (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr) As Dword
   Incr @@pCookie.cRef
   Function = @@pCookie.cRef
End Function
' ****************************************************************************************

' ****************************************************************************************
' HRESULT QueryInterface([in] *GUID riid, [out] **VOID ppvObj)
' Returns the IUnknown of our class and increments the reference counter.
' ****************************************************************************************
Function DWebBrowserEvents2_QueryInterface (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, _
   ByRef riid As Guid, ByRef ppvObj As Dword) As Long
   ppvObj = pCookie
   DWebBrowserEvents2_AddRef pCookie
   Function = %S_OK
End Function
' ****************************************************************************************

' ****************************************************************************************
' UI4 Release()
' Releases our class if there is only a reference to him and decrements the reference counter.
' ****************************************************************************************
Function DWebBrowserEvents2_Release (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr) As Dword
   Local pVtblAddr As Dword
   If @@pCookie.cRef = 1 Then
      If @@pCookie.ppdoc Then
         If @@pCookie.pDocCookie Then HTMLDocumentEvents2_DisconnectEvents @@pCookie.ppdoc, @@pCookie.pDocCookie
         DWebBrowserEvents2_IUnknown_Release @@pCookie.ppdoc
         @@pCookie.pDocCookie = 0
      End If
      pVtblAddr = @@pCookie.pVtblAddr
      If IsFalse HeapFree(GetProcessHeap(), 0, ByVal pVtblAddr) Then
         Function = @@pCookie.cRef
         Exit Function
      End If
   End If
   Decr @@pCookie.cRef
   Function = @@pCookie.cRef
End Function
' ****************************************************************************************

' ****************************************************************************************
' HRESULT GetTypeInfoCount([out] *UINT pctinfo)
' ****************************************************************************************
Function DWebBrowserEvents2_GetTypeInfoCount (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pctInfo As Dword) As Long
   Function = %E_NOTIMPL
End Function
' ****************************************************************************************

' ****************************************************************************************
' HRESULT GetTypeInfo([in] UINT itinfo, [in] UI4 lcid, [out] **VOID pptinfo)
' ****************************************************************************************
Function DWebBrowserEvents2_GetTypeInfo (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, _
   ByVal itinfo As Dword, ByVal lcid As Dword, ByRef pptinfo As Dword) As Long
   Function = %E_NOTIMPL
End Function
' ****************************************************************************************

' ****************************************************************************************
' HRESULT GetIDsOfNames([in] *GUID riid, [in] **I1 rgszNames, [in] UINT cNames, [in] UI4 lcid, [out] *I4 rgdispid)
' ****************************************************************************************
Function DWebBrowserEvents2_GetIDsOfNames ( ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, _
   ByRef riid As Guid, ByVal rgszNames As Dword, ByVal cNames As Dword, ByVal lcid As Dword, ByRef rgdispid As Long) As Long
   Function = %E_NOTIMPL
End Function
' ****************************************************************************************

' ****************************************************************************************
' Builds the IDispatch Virtual Table
' ****************************************************************************************
Function DWebBrowserEvents2_BuildVtbl (ByVal pthis As Dword) As Dword

   Local pVtbl As DWebBrowserEvents2_IDispatchVtbl Ptr
   Local pUnk As DWebBrowserEvents2_IDispatchVtbl Ptr

   pVtbl = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, SizeOf(@pVtbl))
   If pVtbl = 0 Then Exit Function

   @pVtbl.QueryInterface   = CodePtr(DWebBrowserEvents2_QueryInterface)
   @pVtbl.AddRef           = CodePtr(DWebBrowserEvents2_AddRef)
   @pVtbl.Release          = CodePtr(DWebBrowserEvents2_Release)
   @pVtbl.GetTypeInfoCount = CodePtr(DWebBrowserEvents2_GetTypeInfoCount)
   @pVtbl.GetTypeInfo      = CodePtr(DWebBrowserEvents2_GetTypeInfo)
   @pVtbl.GetIDsOfNames    = CodePtr(DWebBrowserEvents2_GetIDsOfNames)
   @pVtbl.Invoke           = CodePtr(DWebBrowserEvents2_Invoke)
   @pVtbl.pVtblAddr        = pVtbl
   @pVtbl.pthis            = pthis
   @pVtbl.fNewWindow3      = %FALSE

   pUnk = VarPtr(@pVtbl.pVtblAddr)
   Function = pUnk

End Function
' ****************************************************************************************

' ****************************************************************************************
' Establishes a connection between the connection point object and the client's sink.
' Returns a token that uniquely identifies this connection.
' ****************************************************************************************
Function DWebBrowserEvents2_ConnectEvents (ByVal pthis As Dword, ByRef pdwCookie As Dword) As Long

   Local HRESULT As Long                 ' HRESULT code
   Local pCPC As Dword                   ' IConnectionPointContainer
   Local pCP As Dword                    ' IConnectionPoint
   Local IID_CPC As Guid                 ' IID_IConnectionPointContainer
   Local IID_CP As Guid                  ' Events dispinterface
   Local dwCookie As Dword               ' Returned token
   Local pUnkSink As Dword               ' IUnknown of the class

   IID_CPC = Guid$("{B196B284-BAB4-101A-B69C-00AA00341D07}")
   IID_CP  = Guid$("{34A715A0-6587-11D0-924A-0020AFC7AC4D}")

   If pthis = 0 Then Function = -1 : Exit Function
   HRESULT = DWebBrowserEvents2_IUnknown_QueryInterface(pthis, IID_CPC, pCPC)
   If HRESULT <> %S_OK Then Function = HRESULT : Exit Function

   HRESULT = DWebBrowserEvents2_IConnectionPointContainer_FindConnectionPoint(pCPC, IID_CP, pCP)
   DWebBrowserEvents2_IUnknown_Release pCPC
   If HRESULT <> %S_OK Then Function = HRESULT : Exit Function

   pUnkSink = DWebBrowserEvents2_BuildVtbl(pthis)
   If IsTrue pUnkSink Then HRESULT = DWebBrowserEvents2_IConnectionPoint_Advise(pCP, pUnkSink, dwCookie)
   DWebBrowserEvents2_IUnknown_Release pCP
   pdwCookie = dwCookie
   Function = HRESULT

End Function
' ****************************************************************************************

' ****************************************************************************************
' Releases the events connection identified with the cookie returned by the ConnectEvents function
' ****************************************************************************************
Function DWebBrowserEvents2_DisconnectEvents (ByVal pthis As Dword, ByVal dwCookie As Dword) As Long

   Local HRESULT As Long                 ' HRESULT code
   Local pCPC As Dword                   ' IConnectionPointContainer
   Local pCP As Dword                    ' IConnectionPoint
   Local IID_CPC As Guid                 ' IID_IConnectionPointContainer
   Local IID_CP As Guid                  ' ConnectionEvents dispinterface

   IID_CPC = Guid$("{B196B284-BAB4-101A-B69C-00AA00341D07}")
   IID_CP  = Guid$("{34A715A0-6587-11D0-924A-0020AFC7AC4D}")

   If pthis = 0 Then Function = -1 : Exit Function
   HRESULT = DWebBrowserEvents2_IUnknown_QueryInterface(pthis, IID_CPC, pCPC)
   If HRESULT <> %S_OK Then Function = HRESULT : Exit Function

   HRESULT = DWebBrowserEvents2_IConnectionPointContainer_FindConnectionPoint(pCPC, IID_CP, pCP)
   DWebBrowserEvents2_IUnknown_Release pCPC
   If HRESULT <> %S_OK Then Function = HRESULT : Exit Function

   HRESULT = DWebBrowserEvents2_IConnectionPoint_Unadvise(pCP, dwCookie)
   DWebBrowserEvents2_IUnknown_Release pCP
   Function = HRESULT

End Function
' ****************************************************************************************

' ****************************************************************************************
' StatusTextChange
' Member identifier: &H00000066 (102)
' Fires when the status bar text of the object has changed.
' The container can use the information provided by this event to update the text of a status bar.
' ****************************************************************************************
Sub DWebBrowserEvents2_StatusTextChange (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Status bar text.
   Local strText As String : strText = Variant$(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' ProgressChange
' Member identifier: &H0000006C (108)
' Fires when the progress of a download operation is updated on the object.
' The container can use the information provided by this event to display the number of bytes
' downloaded so far or to update a progress indicator.
' To calculate the percentage of progress to show in a progress indicator, multiply the value
' of Progress by 100 and divide by the value of ProgressMax (unless Progress is -1, in which
' case the container can indicate that the operation is finished or hide the progress indicator).
' ****************************************************************************************
Sub DWebBrowserEvents2_ProgressChange (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the values of the parameters.
   Local Progress As Long : Progress = Variant#(@pv[1])
   Local ProgressMax As Long : ProgressMax = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' CommandStateChange
' Member identifier: &H00000069 (105)
' Fires when the enabled state of a command changes.
' ****************************************************************************************
Sub DWebBrowserEvents2_CommandStateChange (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the values of the parameters.
   Local nCommand As Long : nCommand = Variant#(@pv[1])
   Local pfEnable As Integer : pfEnable = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' DownloadBegin
' Member identifier: &H0000006A (106)
' Fires when a navigation operation is beginning.
' ****************************************************************************************
Sub DWebBrowserEvents2_DownloadBegin (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis

End Sub
' ****************************************************************************************

' ****************************************************************************************
' DownloadComplete
' Member identifier: &H00000068 (104)
' Fires when a navigation operation finishes, is halted, or fails.
' ****************************************************************************************
Sub DWebBrowserEvents2_DownloadComplete (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis

   ' Connect to the events fired by the downloaded document
   Local ppdoc As Dword
   Local pDocCookie As Dword
   ppdoc = IWebBrowser2_GetDocument(pthis)
   If ppdoc Then
      HTMLDocumentEvents2_ConnectEvents ppdoc, pDocCookie
      @@pCookie.ppdoc = ppdoc
      @@pCookie.pDocCookie = pDocCookie
   End If

End Sub
' ****************************************************************************************

' ****************************************************************************************
' TitleChange
' Member identifier: &H00000071 (113)
' Fires when the title of a document in the object becomes available or changes.
' Because the title might change while an HTML page is downloading, the URL of the document is
' set as the title. After the title specified in the HTML page, if there is one, is parsed, the
' title is changed to reflect the actual title.
' ****************************************************************************************
Sub DWebBrowserEvents2_TitleChange (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local strText As String : strText = Variant$(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' BeforeNavigate2
' Member identifier: &H000000FA (250)
' Fires before navigation occurs in the given object (on either a window or frameset element).
' ****************************************************************************************
Sub DWebBrowserEvents2_BeforeNavigate2 (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Local pDisp As Dword : pDisp = Variant#(@pv[6])
   Local URL As Variant : URL = @pv[5]
   Local Flags As Variant : Flags = @pv[4]
   Local TargetFrameName As Variant : TargetFrameName = @pv[3]
   Local PostData As Variant : PostData = @pv[2]
   Local Headers As Variant : Headers = @pv[1]
   Static bCancel As Integer : bCancel = Variant#(@pv[0])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel

   ' =====================================================================
   ' If there was a previous loaded page, disconnect from the
   ' HTMLDocumentEvents2 interface
   ' =====================================================================
   Local ppdoc As Dword
   Local pDocCookie As Dword
   If @@pCookie.ppdoc Then
      If @@pCookie.pDocCookie Then HTMLDocumentEvents2_DisconnectEvents @@pCookie.ppdoc, @@pCookie.pDocCookie
      DWebBrowserEvents2_IUnknown_Release @@pCookie.ppdoc
      @@pCookie.pDocCookie = 0
   End If
   ' =====================================================================

End Sub
' ****************************************************************************************

' ****************************************************************************************
' NewWindow2
' Member identifier: &H000000FB (251)
' Fires when a new window is to be created.
' BUG: http://support.microsoft.com/kb/294870/EN-US/
' When you use the NewWindow2 event in Internet Explorer 5.5, you may encounter the following
' problems:
'  If you click a link that performs a window.open method to browse to a new site, you receive
'   an "unspecified error" error message.
'  If you right-click a link and then click Open in New Window, it does not navigate at all.
' When you use NewWindow2 in Internet Explorer 5, you may encounter the following problems:
'  If you click a link that performs a window.open method to browse to a new site, it does
'   not navigate at all.
'  If you right-click a link and then click Open in New Window, you receive an "unspecified
'    error" error message.
' When you use NewWindow2 in Internet Explorer 4.x, you may encounter the following problems:
'  If click a link that performs a window.open method to browse to a new site, it does not
'   navigate.
'  If you right-click a link and then click Open in New Window, you receive an "unspecified
'   error" error message.
' To work around this problem, open the link in a new window within your application instead
' of opening it in the same window.
' ****************************************************************************************
Sub DWebBrowserEvents2_NewWindow2 (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Static ppDisp As Dword : ppDisp = Variant#(@pv[1])
'  To return a value, use: ppDisp = <value> : @pvapi[1].vd.@ppdispVal = ppDisp
   Static bCancel As Integer : bCancel = Variant#(@pv[0])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel

End Sub
' ****************************************************************************************

' ****************************************************************************************
' NavigateComplete2
' Member identifier: &H000000FC (252)
' Fires after a navigation to a link is completed on either a window or frameSet element.
' ****************************************************************************************
Sub DWebBrowserEvents2_NavigateComplete2 (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Variants to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Local pDisp As Dword : pDisp = Variant#(@pv[1])
   Local URL As Variant : URL = @pv[0]

End Sub
' ****************************************************************************************

' ****************************************************************************************
' DocumentComplete
' Member identifier: &H00000103 (259)
' Fires when a document has been completely loaded and initialized.
' ****************************************************************************************
Sub DWebBrowserEvents2_DocumentComplete (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Local pDisp As Dword : pDisp = Variant#(@pv[1])
   Local URL As Variant : URL = @pv[0]

End Sub
' ****************************************************************************************

' ****************************************************************************************
' OnVisible
' Member identifier: &H000000FE (254)
' Fires when the IWebBrowser2::Visible property of the object is changed.
' ****************************************************************************************
Sub DWebBrowserEvents2_OnVisible (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local Visible As Integer : Visible = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' WindowSetResizable
' Member identifier: &H00000106 (262)
' Fires to indicate whether the host window should allow or disallow resizing of the object.
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowSetResizable (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local Resizable As Integer : Resizable = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' WindowSetLeft
' Member identifier: &H00000108 (264)
' Fires when the object changes its left position.
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowSetLeft (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local prmLeft As Long : prmLeft = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' Function name: WindowSetTop
' Dispatch interface name: DWebBrowserEvents2
' Member identifier: &H00000109 (265)
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowSetTop (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local Top As Long : Top = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' WindowSetWidth
' Member identifier: &H0000010A (266)
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowSetWidth (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local nWidth As Long : nWidth = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' WindowSetHeight
' Member identifier: &H0000010B (267)
' Fires when the object changes its height.
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowSetHeight (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local Height As Long : Height = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' WindowClosing
' Member identifier: &H00000107 (263)
' ****************************************************************************************
Sub DWebBrowserEvents2_WindowClosing (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Local IsChildWindow As Integer : IsChildWindow = Variant#(@pv[1])
   Static bCancel As Integer : bCancel = Variant#(@pv[0])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel

End Sub
' ****************************************************************************************

' ****************************************************************************************
' ClientToHostWindow
' Member identifier: &H0000010C (268)
' Fires to request that the client window size be converted to the host window size.
' ****************************************************************************************
Sub DWebBrowserEvents2_ClientToHostWindow (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Static CX As Long : CX = Variant#(@pv[1])
'  To return a value, use: CX = <value> : @pvapi[1].vd.@plVal = CX
   Static CY As Long : CY = Variant#(@pv[0])
'  To return a value, use: CY = <value> : @pvapi[0].vd.@plVal = CY

End Sub
' ****************************************************************************************

' ****************************************************************************************
' SetSecureLockIcon
' Member identifier: &H0000010D (269)
' Fires when there is a change in encryption level.
' ****************************************************************************************
Sub DWebBrowserEvents2_SetSecureLockIcon (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local SecureLockIcon As Long : SecureLockIcon = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' FileDownload
' Member identifier: &H0000010E (270)
' Fires to indicate that a file download is about to occur. If a file download dialog is to be
' displayed, this event is fired prior to the display of the dialog.
' ****************************************************************************************
Sub DWebBrowserEvents2_FileDownload (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the value of the parameter.
   Static bCancel As Integer : bCancel = Variant#(@pv[0])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel

End Sub
' ****************************************************************************************

' ****************************************************************************************
' NavigateError
' Member identifier: &H0000010F (271)
' Fires when an error occurs during navigation.
' ****************************************************************************************
Sub DWebBrowserEvents2_NavigateError (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
'  Get the values of the parameters.
   Local pDisp As Dword : pDisp = Variant#(@pv[4])
   Local URL As Variant : URL = @pv[3]
   Local prmFrame As Variant : prmFrame = @pv[2]
   Local StatusCode As Variant : StatusCode = @pv[1]
   Static bCancel As Integer : bCancel = Variant#(@pv[0])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel

End Sub
' ****************************************************************************************

' ****************************************************************************************
' PrintTemplateInstantiation
' Member identifier: &H000000E1 (225)
' Fires when a print template has been instantiated.
' ****************************************************************************************
Sub DWebBrowserEvents2_PrintTemplateInstantiation (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local pDisp As Dword : pDisp = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' PrintTemplateTeardown
' Member identifier: &H000000E2 (226)
' Fires when a print template has been destroyed.
' ****************************************************************************************
Sub DWebBrowserEvents2_PrintTemplateTeardown (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IDispatch of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local pDisp As Dword : pDisp = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' PrivacyImpactedStateChange
' Member identifier: &H00000110 (272)
' Fired when an event occurs that impacts privacy or when a user navigates away from a URL
' that has impacted privacy.
' ****************************************************************************************
Sub DWebBrowserEvents2_PrivacyImpactedStateChange (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IUnknown of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointer to access the parameter.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
'  Get the value of the parameter.
   Local bImpacted As Integer : bImpacted = Variant#(@pv[0])

End Sub
' ****************************************************************************************

' ****************************************************************************************
' Function name: NewWindow3
' Member identifier: &H00000111 (273)
' Raised when a new window is to be created. Extends DWebBrowserEvents2::NewWindow2 with
' additional information about the new window.
' Note: NewWindow3 is available only in Microsoft Windows XP Service Pack 2 (SP2) or later.
' ****************************************************************************************
Sub DWebBrowserEvents2_NewWindow3 (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByRef pdispparams As DispParams)

'  Retrieve the IUnknown of the control that has fired the event.
   Local pthis As Dword : pthis = @@pCookie.pthis
'  Pointers to access the parameters.
   Local pv As Variant Ptr : pv = pdispparams.VariantArgs
   Local pvapi As VARIANTAPI Ptr : pvapi = pv
   Static ppDisp As Dword : ppDisp = Variant#(@pv[4])
'  To return a value, use: ppDisp = <value> : @pvapi[4].vd.@ppdispVal = ppDisp
   Static bCancel As Integer : bCancel = Variant#(@pv[3])
'  To return a value, use: bCancel = <value> : @pvapi[0].vd.@pboolVal = bCancel
   Local dwFlags As Dword : dwFlags = Variant#(@pv[2])
   Local strUrlContext As String : strUrlContext = Variant$(@pv[1])
   Local strUrl As String : strUrl = Variant$(@pv[0])

End Sub
' ****************************************************************************************


' ****************************************************************************************
' HRESULT Invoke([in] I4 dispidMember, [in] *GUID riid, [in] UI4 lcid, [in] UI2 wFlags, [in] *DISPPARAMS pdispparams, [out] *VARIANT pvarResult, [out] *EXCEPINFO pexcepinfo, [out] *UINT puArgErr)
' ****************************************************************************************
Function DWebBrowserEvents2_Invoke (ByVal pCookie As DWebBrowserEvents2_IDispatchVtbl Ptr, ByVal dispidMember As Long, ByRef riid As Guid, _
   ByVal lcid As Dword, ByVal wFlags As Word, ByRef pdispparams As DispParams, ByRef pvarResult As Variant, _
   ByRef pexcepinfo As DWebBrowserEvents2_EXCEPINFO, ByRef puArgErr As Dword) As Long

   Function = %S_OK

   If VarPtr(pdispparams) Then

      Select Case As Long dispidMember
         Case &H00000066  ' (102)  ' // StatusTextChange
            DWebBrowserEvents2_StatusTextChange pCookie, pdispparams
         Case &H0000006C  ' (108)  ' // ProgressChange
            DWebBrowserEvents2_ProgressChange pCookie, pdispparams
         Case &H00000069  ' (105)  ' // CommandStateChange
            DWebBrowserEvents2_CommandStateChange pCookie, pdispparams
         Case &H0000006A  ' (106)  ' // DownloadBegin
            DWebBrowserEvents2_DownloadBegin pCookie, pdispparams
         Case &H00000068  ' (104)  ' // DownloadComplete
            DWebBrowserEvents2_DownloadComplete pCookie, pdispparams
         Case &H00000071  ' (113)  ' // TitleChange
            DWebBrowserEvents2_TitleChange pCookie, pdispparams
         Case &H000000FA  ' (250)  ' // BeforeNavigate2
            DWebBrowserEvents2_BeforeNavigate2 pCookie, pdispparams
         Case &H000000FB  ' (251)  ' // NewWindow2
            DWebBrowserEvents2_NewWindow2 pCookie, pdispparams
         Case &H000000FC  ' (252)  ' // NavigateComplete2
            DWebBrowserEvents2_NavigateComplete2 pCookie, pdispparams
         Case &H00000103  ' (259)  ' // DocumentComplete
            DWebBrowserEvents2_DocumentComplete pCookie, pdispparams
         Case &H000000FE  ' (254)  ' // OnVisible
            DWebBrowserEvents2_OnVisible pCookie, pdispparams
         Case &H00000106  ' (262)  ' // WindowSetResizable
            DWebBrowserEvents2_WindowSetResizable pCookie, pdispparams
         Case &H00000108  ' (264)  ' // WindowSetLeft
            DWebBrowserEvents2_WindowSetLeft pCookie, pdispparams
         Case &H00000109  ' (265)  ' // WindowSetTop
            DWebBrowserEvents2_WindowSetTop pCookie, pdispparams
         Case &H0000010A  ' (266)  ' // WindowSetWidth
            DWebBrowserEvents2_WindowSetWidth pCookie, pdispparams
         Case &H0000010B  ' (267)  ' // WindowSetHeight
            DWebBrowserEvents2_WindowSetHeight pCookie, pdispparams
         Case &H00000107  ' (263)  ' // WindowClosing
            DWebBrowserEvents2_WindowClosing pCookie, pdispparams
         Case &H0000010C  ' (268)  ' // ClientToHostWindow
            DWebBrowserEvents2_ClientToHostWindow pCookie, pdispparams
         Case &H0000010D  ' (269)  ' // SetSecureLockIcon
            DWebBrowserEvents2_SetSecureLockIcon pCookie, pdispparams
         Case &H0000010E  ' (270)  ' // FileDownload
            DWebBrowserEvents2_FileDownload pCookie, pdispparams
         Case &H0000010F  ' (271)  ' // NavigateError
            DWebBrowserEvents2_NavigateError pCookie, pdispparams
         Case &H000000E1  ' (225)  ' // PrintTemplateInstantiation
            DWebBrowserEvents2_PrintTemplateInstantiation pCookie, pdispparams
         Case &H000000E2  ' (226)  ' // PrintTemplateTeardown
            DWebBrowserEvents2_PrintTemplateTeardown pCookie, pdispparams
         Case &H00000110  ' (272)  ' // PrivacyImpactedStateChange
            DWebBrowserEvents2_PrivacyImpactedStateChange pCookie, pdispparams
         Case &H00000111  ' (273)  ' // NewWindow3
            DWebBrowserEvents2_NewWindow3 pCookie, pdispparams

      End Select

   End If

End Function
' ****************************************************************************************
