
' ********************************************************************************************
' Library name: SHDocVw
' Version: 1.1
' Documentation string: Microsoft Internet Controls
' Path: D:\WINDOWS\system32\shdocvw.dll
' Library GUID: {EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}
' Reference guide: http://msdn.microsoft.com/library/default.asp?url=/workshop/browser/webbrowser/r eflist_cpp.asp
' ********************************************************************************************

' ********************************************************************************************
' ATL declarations.
' Note: If you want to use ATL71.DLL, change "ATL.DLL" for "ATL71.DLL" in the declares and
' use "AtlAxWin71" instead of "AtlAxWin" in CreateWindowEx.
' ********************************************************************************************
Declare Function AtlAxWinInit Lib "ATL.DLL" Alias "AtlAxWinInit" () As Long
Declare Function AtlAxGetControl Lib "ATL.DLL" Alias "AtlAxGetControl" (ByVal hWnd As Dword, ByRef pp As Dword) As Long
' ********************************************************************************************

' ********************************************************************************************
' CommandStateChangeConstants enum
' IID: {34A226E0-DF30-11CF-89A9-00A0C9054129}
' Documentation string: Constants for WebBrowser CommandStateChange
' ********************************************************************************************

%CSC_UPDATECOMMANDS                                     = -1           ' &HFFFFFFFF
%CSC_NAVIGATEFORWARD                                    = 1            ' &H00000001
%CSC_NAVIGATEBACK                                       = 2            ' &H00000002

' ********************************************************************************************
' OLECMDID enum
' ********************************************************************************************

%OLECMDID_OPEN                                          = 1            ' &H00000001
%OLECMDID_NEW                                           = 2            ' &H00000002
%OLECMDID_SAVE                                          = 3            ' &H00000003
%OLECMDID_SAVEAS                                        = 4            ' &H00000004
%OLECMDID_SAVECOPYAS                                    = 5            ' &H00000005
%OLECMDID_PRINT                                         = 6            ' &H00000006
%OLECMDID_PRINTPREVIEW                                  = 7            ' &H00000007
%OLECMDID_PAGESETUP                                     = 8            ' &H00000008
%OLECMDID_SPELL                                         = 9            ' &H00000009
%OLECMDID_PROPERTIES                                    = 10           ' &H0000000A
%OLECMDID_CUT                                           = 11           ' &H0000000B
%OLECMDID_COPY                                          = 12           ' &H0000000C
%OLECMDID_PASTE                                         = 13           ' &H0000000D
%OLECMDID_PASTESPECIAL                                  = 14           ' &H0000000E
%OLECMDID_UNDO                                          = 15           ' &H0000000F
%OLECMDID_REDO                                          = 16           ' &H00000010
%OLECMDID_SELECTALL                                     = 17           ' &H00000011
%OLECMDID_CLEARSELECTION                                = 18           ' &H00000012
%OLECMDID_ZOOM                                          = 19           ' &H00000013
%OLECMDID_GETZOOMRANGE                                  = 20           ' &H00000014
%OLECMDID_UPDATECOMMANDS                                = 21           ' &H00000015
%OLECMDID_REFRESH                                       = 22           ' &H00000016
%OLECMDID_STOP                                          = 23           ' &H00000017
%OLECMDID_HIDETOOLBARS                                  = 24           ' &H00000018
%OLECMDID_SETPROGRESSMAX                                = 25           ' &H00000019
%OLECMDID_SETPROGRESSPOS                                = 26           ' &H0000001A
%OLECMDID_SETPROGRESSTEXT                               = 27           ' &H0000001B
%OLECMDID_SETTITLE                                      = 28           ' &H0000001C
%OLECMDID_SETDOWNLOADSTATE                              = 29           ' &H0000001D
%OLECMDID_STOPDOWNLOAD                                  = 30           ' &H0000001E
%OLECMDID_ONTOOLBARACTIVATED                            = 31           ' &H0000001F
%OLECMDID_FIND                                          = 32           ' &H00000020
%OLECMDID_DELETE                                        = 33           ' &H00000021
%OLECMDID_HTTPEQUIV                                     = 34           ' &H00000022
%OLECMDID_HTTPEQUIV_DONE                                = 35           ' &H00000023
%OLECMDID_ENABLE_INTERACTION                            = 36           ' &H00000024
%OLECMDID_ONUNLOAD                                      = 37           ' &H00000025
%OLECMDID_PROPERTYBAG2                                  = 38           ' &H00000026
%OLECMDID_PREREFRESH                                    = 39           ' &H00000027
%OLECMDID_SHOWSCRIPTERROR                               = 40           ' &H00000028
%OLECMDID_SHOWMESSAGE                                   = 41           ' &H00000029
%OLECMDID_SHOWFIND                                      = 42           ' &H0000002A
%OLECMDID_SHOWPAGESETUP                                 = 43           ' &H0000002B
%OLECMDID_SHOWPRINT                                     = 44           ' &H0000002C
%OLECMDID_CLOSE                                         = 45           ' &H0000002D
%OLECMDID_ALLOWUILESSSAVEAS                             = 46           ' &H0000002E
%OLECMDID_DONTDOWNLOADCSS                               = 47           ' &H0000002F
%OLECMDID_UPDATEPAGESTATUS                              = 48           ' &H00000030
%OLECMDID_PRINT2                                        = 49           ' &H00000031
%OLECMDID_PRINTPREVIEW2                                 = 50           ' &H00000032
%OLECMDID_SETPRINTTEMPLATE                              = 51           ' &H00000033
%OLECMDID_GETPRINTTEMPLATE                              = 52           ' &H00000034
%OLECMDID_PAGEACTIONBLOCKED                             = 55           ' &H00000037
%OLECMDID_PAGEACTIONUIQUERY                             = 56           ' &H00000038
%OLECMDID_FOCUSVIEWCONTROLS                             = 57           ' &H00000039
%OLECMDID_FOCUSVIEWCONTROLSQUERY                        = 58           ' &H0000003A
%OLECMDID_SHOWPAGEACTIONMENU                            = 59           ' &H0000003B

' ********************************************************************************************
' OLECMDF enum
' ********************************************************************************************

%OLECMDF_SUPPORTED                                      = 1            ' &H00000001
%OLECMDF_ENABLED                                        = 2            ' &H00000002
%OLECMDF_LATCHED                                        = 4            ' &H00000004
%OLECMDF_NINCHED                                        = 8            ' &H00000008
%OLECMDF_INVISIBLE                                      = 16           ' &H00000010
%OLECMDF_DEFHIDEONCTXTMENU                              = 32           ' &H00000020

' ********************************************************************************************
' OLECMDEXECOPT enum
' ********************************************************************************************

%OLECMDEXECOPT_DODEFAULT                                = 0            ' &H00000000
%OLECMDEXECOPT_PROMPTUSER                               = 1            ' &H00000001
%OLECMDEXECOPT_DONTPROMPTUSER                           = 2            ' &H00000002
%OLECMDEXECOPT_SHOWHELP                                 = 3            ' &H00000003

' ********************************************************************************************
' tagREADYSTATE enum
' ********************************************************************************************

%READYSTATE_UNINITIALIZED                               = 0            ' &H00000000
%READYSTATE_LOADING                                     = 1            ' &H00000001
%READYSTATE_LOADED                                      = 2            ' &H00000002
%READYSTATE_INTERACTIVE                                 = 3            ' &H00000003
%READYSTATE_COMPLETE                                    = 4            ' &H00000004

' ********************************************************************************************
' SecureLockIconConstants enum
' IID: {65507BE0-91A8-11D3-A845-009027220E6D}
' Documentation string: Constants for WebBrowser security icon notification
' ********************************************************************************************

%secureLockIconUnsecure                                 = 0            ' &H00000000
%secureLockIconMixed                                    = 1            ' &H00000001
%secureLockIconSecureUnknownBits                        = 2            ' &H00000002
%secureLockIconSecure40Bit                              = 3            ' &H00000003
%secureLockIconSecure56Bit                              = 4            ' &H00000004
%secureLockIconSecureFortezza                           = 5            ' &H00000005
%secureLockIconSecure128Bit                             = 6            ' &H00000006

' ********************************************************************************************
' ShellWindowTypeConstants enum
' IID: {F41E6981-28E5-11D0-82B4-00A0C90C29C5}
' Documentation string: Constants for ShellWindows registration
' ********************************************************************************************

%SWC_EXPLORER                                           = 0            ' &H00000000
%SWC_BROWSER                                            = 1            ' &H00000001
%SWC_3RDPARTY                                           = 2            ' &H00000002
%SWC_CALLBACK                                           = 4            ' &H00000004

' ********************************************************************************************
' ShellWindowFindWindowOptions enum
' IID: {7716A370-38CA-11D0-A48B-00A0C90A8F39}
' Documentation string: Options for ShellWindows FindWindow
' ********************************************************************************************

%SWFO_NEEDDISPATCH                                      = 1            ' &H00000001
%SWFO_INCLUDEPENDING                                    = 2            ' &H00000002
%SWFO_COOKIEPASSED                                      = 4            ' &H00000004

' ********************************************************************************************
' NWMF Enumerated Type
' Flags used by INewWindowManager::EvaluateNewWindow. These values are taken into account in
' the decision of whether to display a pop-up window.
' ********************************************************************************************

%NWMF_UNLOADING        = &H0001
%NWMF_USERINITED       = &H0002
%NWMF_FIRST_USERINITED = &H0004
%NWMF_OVERRIDEKEY      = &H0008
%NWMF_SHOWHELP         = &H0010
%NWMF_HTMLDIALOG       = &H0020
%NWMF_FROMPROXY        = &H0040

' ********************************************************************************************
' Global error variable
' ********************************************************************************************
Global WbResult As Long
' ********************************************************************************************

' ********************************************************************************************
' QueryInterface method
' ********************************************************************************************
' Returns a pointer to a specified interface on an object to which a client currently holds an
' interface pointer. You must release the returned interface, when no longer needed, with a call
' to the Release method.
' ********************************************************************************************
Declare Function Proto_WbQueryInterface (ByVal pthis As Dword Ptr, ByRef riid As Guid, ByRef ppvObj As Dword) As Long
' ********************************************************************************************
Function WbQueryInterface (ByVal pthis As Dword Ptr, ByRef riid As Guid) As Dword
    Local ppvObj As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Call Dword @@pthis[0] Using Proto_WbQueryInterface(pthis, riid, ppvObj) To WbResult
    Function = ppvObj
End Function
' ********************************************************************************************

' ********************************************************************************************
' AddRef method
' ********************************************************************************************
' The AddRef method increments the reference count for an interface on an object. It should be
' called for every new copy of a pointer to an interface on a given object.
' ********************************************************************************************
Function WbAddRef (ByVal pthis As Dword Ptr) As Dword
    Local DWRESULT As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Call Dword @@pthis[1] Using WbAddRef(pthis) To DWRESULT
    Function = DWRESULT
End Function
' ********************************************************************************************

' ********************************************************************************************
' Release method
' ********************************************************************************************
' Decrements the reference count for the calling interface on a object. If the reference count
' on the object falls to 0, the object is freed from memory.
' ********************************************************************************************
Function WbRelease (ByVal pthis As Dword Ptr) As Dword
    Local DWRESULT As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Call Dword @@pthis[2] Using WbRelease(pthis) To DWRESULT
    Function = DWRESULT
End Function
' ********************************************************************************************

' ********************************************************************************************
' Retrieves the interface of the ActiveX control given the handle of its ATL container
' ********************************************************************************************
Function WbGetInterfacePointer (ByVal hCtrl As Dword) As Dword

    Local ppUnk As Dword
    Local IID_IDispatch As Guid
    Local ppDispatch As Dword

    ' Get the IUnknown of the OCX hosted in the control
    WbResult = AtlAxGetControl(hCtrl, ppUnk)
    If IsTrue WbResult Or IsFalse ppUnk Then Exit Function
    IID_IDispatch = Guid$("{00020400-0000-0000-c000-000000000046}")

    ' Query for the existence of the IDispatch interface
    ppDispatch = WbQueryInterface(ppUnk, IID_IDispatch)

    ' If not found, return the IUnknown of the control
    If IsTrue WbResult Or IsFalse ppDispatch Then
       Function = ppUnk
       Exit Function
    End If

    ' Release the IUnknown of the control
    WbRelease ppUnk

    ' Return the retrieved address
    Function = ppDispatch

End Function
' ********************************************************************************************

' ********************************************************************************************
' IWebBrowser2 interface
' IID: {D30C1661-CDAF-11D0-8A3E-00C04FC9E26E}
' Interface flags: &H1050 [Hidden] [Dual] [Dispatchable]
' ********************************************************************************************

' ********************************************************************************************
' GoBack method
' Navigates to the previous item in the history list.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GoBack (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_GoBack (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[7] Using Proto_IWebBrowser2_GoBack(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' GoForward method
' Navigates to the next item in the history list.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GoForward (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_GoForward (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[8] Using Proto_IWebBrowser2_GoForward(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' GoHome method
' Go home/start page.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GoHome (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_GoHome (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[9] Using Proto_IWebBrowser2_GoHome(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' GoSearch method
' Go Search Page.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GoSearch (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_GoSearch (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[10] Using Proto_IWebBrowser2_GoSearch(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' Navigate method
' Navigates to a URL or file.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Navigate (ByVal pthis As Dword Ptr, ByVal URL As Dword, ByRef Flags As Variant, ByRef TargetFrameName As Variant, ByRef PostData As Variant, ByRef Headers As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_Navigate (ByVal pthis As Dword Ptr, ByVal URL As String, Optional ByRef Flags As Variant, ByRef TargetFrameName As Variant, ByRef PostData As Variant, ByRef Headers As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    URL = UCode$(URL)
    Dim var_Flags As Variant : If VarPtr(Flags) Then var_Flags = Flags Else var_Flags = Error %DISP_E_PARAMNOTFOUND
    Dim var_TargetFrameName As Variant : If VarPtr(TargetFrameName) Then var_TargetFrameName = TargetFrameName Else var_TargetFrameName = Error %DISP_E_PARAMNOTFOUND
    Dim var_PostData As Variant : If VarPtr(PostData) Then var_PostData = PostData Else var_PostData = Error %DISP_E_PARAMNOTFOUND
    Dim var_Headers As Variant : If VarPtr(Headers) Then var_Headers = Headers Else var_Headers = Error %DISP_E_PARAMNOTFOUND
    Call Dword @@pthis[11] Using Proto_IWebBrowser2_Navigate(pthis, StrPtr(URL), var_Flags, var_TargetFrameName, var_PostData, var_Headers) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' Refresh method
' Refresh the currently viewed page.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Refresh (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_Refresh (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[12] Using Proto_IWebBrowser2_Refresh(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' Refresh2 method
' Refresh the currently viewed page.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Refresh2 (ByVal pthis As Dword Ptr, ByRef Level As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_Refresh2 (ByVal pthis As Dword Ptr, Optional ByRef Level As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Dim var_Level As Variant : If VarPtr(Level) Then var_Level = Level Else var_Level = Error %DISP_E_PARAMNOTFOUND
    Call Dword @@pthis[13] Using Proto_IWebBrowser2_Refresh2(pthis, var_Level) To WbResult
    If VarPtr(Level) Then Level = var_Level
End Sub
' ********************************************************************************************

' ********************************************************************************************
' Stop method
' Stops opening a file.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Stop (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_Stop (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[14] Using Proto_IWebBrowser2_Stop(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Application property
' Returns the application automation object if accessible, this automation object otherwise..
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetApplication (ByVal pthis As Dword Ptr, ByRef pRetVal As Dword) As Long
' ********************************************************************************************
Function IWebBrowser2_GetApplication (ByVal pthis As Dword Ptr) As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Dword
    Call Dword @@pthis[15] Using Proto_IWebBrowser2_GetApplication(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Parent property
' Returns the automation object of the container/parent if one exists or this automation object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetParent (ByVal pthis As Dword Ptr, ByRef pRetVal As Dword) As Long
' ********************************************************************************************
Function IWebBrowser2_GetParent (ByVal pthis As Dword Ptr) As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Dword
    Call Dword @@pthis[16] Using Proto_IWebBrowser2_GetParent(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Container property
' Returns the container/parent automation object, if any.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetContainer (ByVal pthis As Dword Ptr, ByRef pRetVal As Dword) As Long
' ********************************************************************************************
Function IWebBrowser2_GetContainer (ByVal pthis As Dword Ptr) As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Dword
    Call Dword @@pthis[17] Using Proto_IWebBrowser2_GetContainer(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Document property
' Returns the active Document automation object, if any.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetDocument (ByVal pthis As Dword Ptr, ByRef pRetVal As Dword) As Long
' ********************************************************************************************
Function IWebBrowser2_GetDocument (ByVal pthis As Dword Ptr) As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Dword
    Call Dword @@pthis[18] Using Proto_IWebBrowser2_GetDocument(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]TopLevelContainer property
' Returns True if this is the top level object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetTopLevelContainer (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetTopLevelContainer (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[19] Using Proto_IWebBrowser2_GetTopLevelContainer(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Type property
' Returns the type of the contained document object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetType (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetType (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[20] Using Proto_IWebBrowser2_GetType(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Left property
' The horizontal position (pixels) of the frame window relative to the screen/container.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetLeft (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetLeft (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[21] Using Proto_IWebBrowser2_GetLeft(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Left property
' The horizontal position (pixels) of the frame window relative to the screen/container.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetLeft (ByVal pthis As Dword Ptr, ByVal prmLeft As Long) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetLeft (ByVal pthis As Dword Ptr, ByVal prmLeft As Long)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[22] Using Proto_IWebBrowser2_SetLeft(pthis, prmLeft) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Top property
' The vertical position (pixels) of the frame window relative to the screen/container.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetTop (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetTop (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[23] Using Proto_IWebBrowser2_GetTop(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Top property
' The vertical position (pixels) of the frame window relative to the screen/container.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetTop (ByVal pthis As Dword Ptr, ByVal prmTop As Long) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetTop (ByVal pthis As Dword Ptr, ByVal prmTop As Long)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[24] Using Proto_IWebBrowser2_SetTop(pthis, prmTop) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Width property
' The horizontal dimension (pixels) of the frame window/object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetWidth (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetWidth (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[25] Using Proto_IWebBrowser2_GetWidth(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Width property
' The horizontal dimension (pixels) of the frame window/object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetWidth (ByVal pthis As Dword Ptr, ByVal prmWidth As Long) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetWidth (ByVal pthis As Dword Ptr, ByVal prmWidth As Long)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[26] Using Proto_IWebBrowser2_SetWidth(pthis, prmWidth) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Height property
' The vertical dimension (pixels) of the frame window/object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetHeight (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetHeight (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[27] Using Proto_IWebBrowser2_GetHeight(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Height property
' The vertical dimension (pixels) of the frame window/object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetHeight (ByVal pthis As Dword Ptr, ByVal prmHeight As Long) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetHeight (ByVal pthis As Dword Ptr, ByVal prmHeight As Long)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[28] Using Proto_IWebBrowser2_SetHeight(pthis, prmHeight) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]LocationName property
' Gets the short (UI-friendly) name of the URL/file currently viewed.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetLocationName (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetLocationName (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[29] Using Proto_IWebBrowser2_GetLocationName(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]LocationURL property
' Gets the full URL/path currently viewed.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetLocationURL (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetLocationURL (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[30] Using Proto_IWebBrowser2_GetLocationURL(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Busy property
' Query to see if something is still in progress.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetBusy (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetBusy (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[31] Using Proto_IWebBrowser2_GetBusy(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' Quit method
' Exits application and closes the open document.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Quit (ByVal pthis As Dword Ptr) As Long
' ********************************************************************************************
Sub IWebBrowser2_Quit (ByVal pthis As Dword Ptr)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[32] Using Proto_IWebBrowser2_Quit(pthis) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' PutProperty method
' Associates vtValue with the name szProperty in the context of the object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_PutProperty (ByVal pthis As Dword Ptr, ByVal Property As Dword, ByVal vtValue As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_PutProperty (ByVal pthis As Dword Ptr, ByVal Property As String, ByVal vtValue As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Property = UCode$(Property)
    Call Dword @@pthis[34] Using Proto_IWebBrowser2_PutProperty(pthis, StrPtr(Property), vtValue) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' GetProperty method
' Retrieve the Associated value for the property vtValue in the context of the object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetProperty (ByVal pthis As Dword Ptr, ByVal Property As Dword, ByRef pRetVal As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_GetProperty (ByVal pthis As Dword Ptr, ByVal Property As String, ByRef pRetVal As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Property = UCode$(Property)
    Call Dword @@pthis[35] Using Proto_IWebBrowser2_GetProperty(pthis, StrPtr(Property), pRetVal) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Name property
' Returns name of the application.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetName (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetName (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[36] Using Proto_IWebBrowser2_GetName(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]HWND property
' Returns the HWND of the current IE window.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetHWND (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetHWND (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[37] Using Proto_IWebBrowser2_GetHWND(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]FullName property
' Returns file specification of the application, including path.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetFullName (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetFullName (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[38] Using Proto_IWebBrowser2_GetFullName(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Path property
' Returns the path to the application.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetPath (ByVal pthis As Dword Ptr, ByRef pRetVal As String) As Long
' ********************************************************************************************
Function IWebBrowser2_GetPath (ByVal pthis As Dword Ptr) As String
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As String
    Call Dword @@pthis[39] Using Proto_IWebBrowser2_GetPath(pthis, pRetVal) To WbResult
    Function = ACode$(pRetVal)
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Visible property
' Determines whether the application is visible or hidden.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetVisible (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetVisible (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[40] Using Proto_IWebBrowser2_GetVisible(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Visible property
' Determines whether the application is visible or hidden.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetVisible (ByVal pthis As Dword Ptr, ByVal pfVisible As Integer) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetVisible (ByVal pthis As Dword Ptr, ByVal pfVisible As Integer)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    If pfVisible <> 0 Then pfVisible = -1
    Call Dword @@pthis[41] Using Proto_IWebBrowser2_SetVisible(pthis, pfVisible) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' Navigate2 method
' Navigates to a URL or file or pidl.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_Navigate2 (ByVal pthis As Dword Ptr, ByRef URL As Variant, ByRef Flags As Variant, ByRef TargetFrameName As Variant, ByRef PostData As Variant, ByRef Headers As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_Navigate2 (ByVal pthis As Dword Ptr, ByRef URL As Variant, Optional ByRef Flags As Variant, ByRef TargetFrameName As Variant, ByRef PostData As Variant, ByRef Headers As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Dim var_Flags As Variant : If VarPtr(Flags) Then var_Flags = Flags Else var_Flags = Error %DISP_E_PARAMNOTFOUND
    Dim var_TargetFrameName As Variant : If VarPtr(TargetFrameName) Then var_TargetFrameName = TargetFrameName Else var_TargetFrameName = Error %DISP_E_PARAMNOTFOUND
    Dim var_PostData As Variant : If VarPtr(PostData) Then var_PostData = PostData Else var_PostData = Error %DISP_E_PARAMNOTFOUND
    Dim var_Headers As Variant : If VarPtr(Headers) Then var_Headers = Headers Else var_Headers = Error %DISP_E_PARAMNOTFOUND
    Call Dword @@pthis[52] Using Proto_IWebBrowser2_Navigate2(pthis, URL, var_Flags, var_TargetFrameName, var_PostData, var_Headers) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' QueryStatusWB method
' IOleCommandTarget::QueryStatus
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_QueryStatusWB (ByVal pthis As Dword Ptr, ByVal cmdID As Long, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_QueryStatusWB (ByVal pthis As Dword Ptr, ByVal cmdID As Long) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[53] Using Proto_IWebBrowser2_QueryStatusWB(pthis, cmdID, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' ExecWB method
' IOleCommandTarget::Exec
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_ExecWB (ByVal pthis As Dword Ptr, ByVal cmdID As Long, ByVal cmdexecopt As Long, ByRef pvaIn As Variant, ByRef pvaOut As Variant) As Long
' ********************************************************************************************
Sub IWebBrowser2_ExecWB (ByVal pthis As Dword Ptr, ByVal cmdID As Long, ByVal cmdexecopt As Long, Optional ByRef pvaIn As Variant, ByRef pvaOut As Variant)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    Dim var_pvaIn As Variant : If VarPtr(pvaIn) Then var_pvaIn = pvaIn Else var_pvaIn = Error %DISP_E_PARAMNOTFOUND
    Dim var_pvaOut As Variant : If VarPtr(pvaOut) Then var_pvaOut = pvaOut Else var_pvaOut = Error %DISP_E_PARAMNOTFOUND
    Call Dword @@pthis[54] Using Proto_IWebBrowser2_ExecWB(pthis, cmdID, cmdexecopt, var_pvaIn, var_pvaOut) To WbResult
    If VarPtr(pvaOut) Then pvaOut = var_pvaOut
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]ReadyState property  [Bindable]
' Retrieves the ready state of the object.
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetReadyState (ByVal pthis As Dword Ptr, ByRef pRetVal As Long) As Long
' ********************************************************************************************
Function IWebBrowser2_GetReadyState (ByVal pthis As Dword Ptr) As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Long
    Call Dword @@pthis[56] Using Proto_IWebBrowser2_GetReadyState(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [get]Offline property
' Documentation string: Controls if the frame is offline (read from cache)
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetOffline (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetOffline (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[57] Using Proto_IWebBrowser2_GetOffline(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Offline property
' Controls if the frame is offline (read from cache)
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetOffline (ByVal pthis As Dword Ptr, ByVal pfOffline As Integer) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetOffline (ByVal pthis As Dword Ptr, ByVal pfOffline As Integer)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    If pfOffline <> 0 Then pfOffline = -1
    Call Dword @@pthis[58] Using Proto_IWebBrowser2_SetOffline(pthis, pfOffline) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]Silent property
' Controls if any dialog boxes can be shown
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetSilent (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetSilent (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[59] Using Proto_IWebBrowser2_GetSilent(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]Silent property
' Controls if any dialog boxes can be shown
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetSilent (ByVal pthis As Dword Ptr, ByVal pfSilent As Integer) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetSilent (ByVal pthis As Dword Ptr, ByVal pfSilent As Integer)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    If pfSilent <> 0 Then pfSilent = -1
    Call Dword @@pthis[60] Using Proto_IWebBrowser2_SetSilent(pthis, pfSilent) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]RegisterAsBrowser property
' Registers OC as a top-level browser (for target name resolution)
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetRegisterAsBrowser (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetRegisterAsBrowser (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[61] Using Proto_IWebBrowser2_GetRegisterAsBrowser(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]RegisterAsBrowser property
' Registers OC as a top-level browser (for target name resolution)
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetRegisterAsBrowser (ByVal pthis As Dword Ptr, ByVal pfRegisterAsBrowser As Integer) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetRegisterAsBrowser (ByVal pthis As Dword Ptr, ByVal pfRegisterAsBrowser As Integer)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    If pfRegisterAsBrowser <> 0 Then pfRegisterAsBrowser = -1
    Call Dword @@pthis[62] Using Proto_IWebBrowser2_SetRegisterAsBrowser(pthis, pfRegisterAsBrowser) To WbResult
End Sub
' ********************************************************************************************

' ********************************************************************************************
' [get]RegisterAsDropTarget property
' Registers OC as a drop target for navigation
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_GetRegisterAsDropTarget (ByVal pthis As Dword Ptr, ByRef pRetVal As Integer) As Long
' ********************************************************************************************
Function IWebBrowser2_GetRegisterAsDropTarget (ByVal pthis As Dword Ptr) As Integer
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Dim pRetVal As Integer
    Call Dword @@pthis[63] Using Proto_IWebBrowser2_GetRegisterAsDropTarget(pthis, pRetVal) To WbResult
    Function = pRetVal
End Function
' ********************************************************************************************

' ********************************************************************************************
' [set]RegisterAsDropTarget property
' Registers OC as a drop target for navigation
' ********************************************************************************************
Declare Function Proto_IWebBrowser2_SetRegisterAsDropTarget (ByVal pthis As Dword Ptr, ByVal pfRegisterAsDropTarget As Integer) As Long
' ********************************************************************************************
Sub IWebBrowser2_SetRegisterAsDropTarget (ByVal pthis As Dword Ptr, ByVal pfRegisterAsDropTarget As Integer)
    If pthis = 0 Then WbResult = %E_POINTER : Exit Sub
    If pfRegisterAsDropTarget <> 0 Then pfRegisterAsDropTarget = -1
    Call Dword @@pthis[64] Using Proto_IWebBrowser2_SetRegisterAsDropTarget(pthis, pfRegisterAsDropTarget) To WbResult
End Sub
' ********************************************************************************************



'
