#Dim All
#Compile Exe
#Option Version4
#Include "WIN32API.INC"
#Include "COMMCTRL.INC"
#Include "IEWB2.INC"

Global HtmlResult As Long

Type SAFEARRAYBOUND
  cElements As Dword
  lLbound   As Long
End Type

Declare Function SafeArrayCreate Lib "OLEAUT32.DLL" Alias "SafeArrayCreate" (ByVal vt As Word, ByVal cDims As Dword, ByRef rgsabound As SAFEARRAYBOUND) As Dword
Declare Function SafeArrayDestroy Lib "OLEAUT32.DLL" Alias "SafeArrayDestroy" (ByVal psa As Dword) As Dword
Declare Function SafeArrayPutElement Lib "OLEAUT32.DLL" Alias "SafeArrayPutElement" (ByVal psa As Dword, ByVal rgIndices As Dword, ByVal pv As Dword) As Dword

' ********************************************************************************************
' QueryInterface method
' ********************************************************************************************
' Returns a pointer to a specified interface on an object to which a client currently holds an
' interface pointer. You must release the returned interface, when no longer needed, with a call
' to the Release method.
' ********************************************************************************************
Declare Function Proto_HtmlQueryInterface (ByVal pthis As Dword Ptr, ByRef riid As Guid, ByRef ppvObj As Dword) As Long
' ********************************************************************************************
Function HtmlQueryInterface (ByVal pthis As Dword Ptr, ByRef riid As Guid) As Dword
    Local ppvObj As Dword
    If pthis = 0 Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[0] Using Proto_WbQueryInterface(pthis, riid, ppvObj) To HtmlResult
    Function = ppvObj
End Function
' ********************************************************************************************

' ********************************************************************************************
' AddRef method
' ********************************************************************************************
' The AddRef method increments the reference count for an interface on an object. It should be
' called for every new copy of a pointer to an interface on a given object.
' ********************************************************************************************
Function HtmlAddRef (ByVal pthis As Dword Ptr) As Dword
    Local DWRESULT As Long
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Call Dword @@pthis[1] Using HtmlAddRef(pthis) To DWRESULT
    Function = DWRESULT
End Function
' ********************************************************************************************

' ********************************************************************************************
' Release method
' ********************************************************************************************
' Decrements the reference count for the calling interface on a object. If the reference count
' on the object falls to 0, the object is freed from memory.
' ********************************************************************************************
Function HtmlRelease (ByVal pthis As Dword Ptr) As Dword
    Local DWRESULT As Dword
    If pthis = 0 Then WbResult = %E_POINTER : Exit Function
    Call Dword @@pthis[2] Using HtmlRelease(pthis) To DWRESULT
    Function = DWRESULT
End Function
' ********************************************************************************************

' ****************************************************************************************
' write method
' Writes one or more HTML expressions to a document in the specified window.
' Parameter:
'    psarray
'        [in] BSTR that specifies the text and HTML tags to write.
' Note: This function expects that you pass an unicode string in a safearray of variants.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_write ( _
    ByVal pthis As Dword Ptr _                          ' %VT_DISPATCH <dispinterface>
  , ByVal psarray As Dword _                            ' %VT_SAFEARRAY [in]
    ) As Long                                           ' %VT_HRESULT <LONG>
' ****************************************************************************************
Sub IHTMLDocument2_write (ByVal pthis As Dword Ptr, ByVal strScript As String)
    Local psarray As Dword, ix As Long, vScript As Variant, rgsabound As SAFEARRAYBOUND
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    ' Create a safearray of variants of one element
    rgsabound.lLBound = 0 : rgsabound.cElements = 1
    psarray = SafeArrayCreate(%VT_Variant, 1, rgsabound)
    If IsFalse psarray Then HtmlResult = %E_POINTER : Exit Sub
    ' Fill the safearray with the script
    vScript = strScript : ix = 0
    SafeArrayPutElement(psarray, ByVal VarPtr(ix), ByVal VarPtr(vScript))
    ' Do the call
    Call Dword @@pthis[59] Using Proto_IHTMLDocument2_write(pthis, psarray) To HtmlResult
    ' Destroy the safearray
    SafeArrayDestroy psarray
End Sub
' ****************************************************************************************

' ****************************************************************************************
' writeln method
' Writes one or more HTML expressions, followed by a carriage return, to a document in the
' specified window.
' Parameters
'    psarray
'        [in] BSTR that specifies the text and HTML tags to write.
' Return Value
'    Returns %S_OK if successful, or an error value otherwise.
' Remarks
'    In HTML, the carriage return is ignored unless it occurs within preformatted text.
' Note: This function expects that you pass an unicode string in a safearray of variants.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_writeln ( _
    ByVal pthis As Dword Ptr _                          ' %VT_DISPATCH <dispinterface>
  , ByVal psarray As Dword _                            ' %VT_SAFEARRAY [in]
    ) As Long                                           ' %VT_HRESULT <LONG>
' ****************************************************************************************
Sub IHTMLDocument2_writeln (ByVal pthis As Dword Ptr, ByVal strScript As String)
    Local psarray As Dword, ix As Long, vScript As Variant, rgsabound As SAFEARRAYBOUND
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    ' Create a safearray of variants of one element
    rgsabound.lLBound = 0 : rgsabound.cElements = 1
    psarray = SafeArrayCreate(%VT_Variant, 1, rgsabound)
    If IsFalse psarray Then HtmlResult = %E_POINTER : Exit Sub
    ' Fill the safearray with the script
    vScript = strScript : ix = 0
    SafeArrayPutElement(psarray, ByVal VarPtr(ix), ByVal VarPtr(vScript))
    ' Do the call
    Call Dword @@pthis[60] Using Proto_IHTMLDocument2_writeln(pthis, psarray) To HtmlResult
    ' Destroy the safearray
    SafeArrayDestroy psarray
End Sub
' ****************************************************************************************

' ****************************************************************************************
' close method
' Closes an output stream and forces the sent data to display.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_close (ByVal pthis As Dword Ptr) As Long
' ****************************************************************************************
Sub IHTMLDocument2_close (ByVal pthis As Dword Ptr)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[62] Using Proto_IHTMLDocument2_close (pthis) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' [get_]innerHTML property
' Retrieves the HTML between the start and end tags of the object.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_get_innerHTML (ByVal pthis As Dword Ptr, ByRef p As String) As Long
' ****************************************************************************************
Function IHTMLElement_get_innerHTML (ByVal pthis As Dword Ptr) As String
    Local p As String
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[58] Using Proto_IHTMLElement_get_innerHTML(pthis, p) To HtmlResult
    Function = ACode$(p)
End Function
' ****************************************************************************************

' ****************************************************************************************
' [put_]innerHTML property
' Interface name = IHTMLElement
' VTable offset = 228
' DispID = -2147417086 [&H80010402]
' ****************************************************************************************
Declare Function Proto_IHTMLElement_put_innerHTML (ByVal pthis As Dword Ptr, ByVal p As Dword) As Long
' ****************************************************************************************
Sub IHTMLElement_put_innerHTML (ByVal pthis As Dword Ptr, ByVal p As String)
    p = UCode$(p)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[57] Using Proto_IHTMLElement_put_innerHTML(pthis, StrPtr(p)) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' [get_]id property
' Retrieves the string identifying the object.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_get_id (ByVal pthis As Dword Ptr, ByRef p As String) As Long
' ****************************************************************************************
Function IHTMLElement_get_id (ByVal pthis As Dword Ptr) As String
    Local p As String
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[13] Using Proto_IHTMLElement_get_id(pthis, p) To HtmlResult
    Function = ACode$(p)
End Function
' ****************************************************************************************

' ****************************************************************************************
' [put_]id property
' Sets the string identifying the object.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_put_id (ByVal pthis As Dword Ptr, ByVal p As Dword) As Long
' ****************************************************************************************
Sub IHTMLElement_put_id (ByVal pthis As Dword Ptr, ByVal p As String)
    p = UCode$(p)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[12] Using Proto_IHTMLElement_put_id(pthis, StrPtr(p)) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' getElementById method
' Returns a reference to the first object with the specified value of the ID attribute.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument3_getElementById (ByVal pthis As Dword Ptr, ByVal v As String Ptr, ByRef pel As Dword) As Long
' ****************************************************************************************
Function IHTMLDocument3_getElementById (ByVal pthis As Dword Ptr, ByVal v As String) As Dword
    Local pel As Dword
    v = UCode$(v)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Local HRESULT As Long
    Call Dword @@pthis[46] Using Proto_IHTMLDocument3_getElementById(pthis, StrPtr(v), pel) To HtmlResult
    Function = pel
End Function
' ****************************************************************************************

' ****************************************************************************************
' getAttribute method
' Retrieves the value of the specified attribute.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_getAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As String Ptr, ByVal lFlags As Long, ByRef AttributeValue As Variant) As Long
' ****************************************************************************************
Sub IHTMLElement_getAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As String, ByVal lFlags As Long, ByRef AttributeValue As Variant)
    strAttributeName = UCode$(strAttributeName)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[8] Using Proto_IHTMLElement_getAttribute(pthis, StrPtr(strAttributeName), lFlags, AttributeValue) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' setAttribute method
' Sets the value of the specified attribute.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_setAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As Dword, ByVal AttributeValue As Variant, ByVal lFlags As Long) As Long
' ****************************************************************************************
Sub IHTMLElement_setAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As String, ByVal AttributeValue As Variant, Optional ByRef lFlags As Long)
    Local Flags As Long
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    strAttributeName = UCode$(strAttributeName)
    If VarPtr(lFlags) Then Flags = lFlags Else Flags = 1
    Call Dword @@pthis[7] Using Proto_IHTMLElement_setAttribute(pthis, StrPtr(strAttributeName), AttributeValue, Flags) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' removeAttribute method
' Removes the given attribute from the object.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_removeAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As Dword, ByVal lFlags As Long, ByRef pfSuccess As Integer) As Long
' ****************************************************************************************
Function IHTMLElement_removeAttribute (ByVal pthis As Dword Ptr, ByVal strAttributeName As String, Optional ByRef lFlags As Long) As Integer
    Local pfSuccess As Integer
    Local Flags As Long
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    strAttributeName = UCode$(strAttributeName)
    If VarPtr(lFlags) Then Flags = lFlags Else Flags = 1
    Call Dword @@pthis[9] Using Proto_IHTMLElement_removeAttribute(pthis, StrPtr(strAttributeName), Flags, pfSuccess) To HtmlResult
    Function = pfSuccess
End Function
' ****************************************************************************************

' ****************************************************************************************
' HTMLDocument_GetElementValueById
' Parameters:
' - pthis = Reference to the IHTMLDocument interface
' - strId = The value of the ID attribute
' Return Value:
' An string containing the value as ddefined by the attribute.
' This method performs a case insensitive property search.
' If two or more attributes have the same name (differing only in uppercase and lowercase
' letters) this function retrieves values only for the last attribute created with this
' name, and ignores all other attributes with the same name.
' When retrieving the CLASS attribute using this method, set the strAttributeName to be
' "className", which is the corresponding Dynamic HTML (DHTML) property.
' This function is used only by events created from HTML Components.
' HtmlResult will be filled with %S_OK if successful, or an error value otherwise.
' ****************************************************************************************
Function HTMLDocument_GetElementValueById (ByVal pthis As Dword, ByVal strId As String) As String

   Local ppDoc3 As Dword                ' // Reference to the IHTMLDocument3 interface
   Local ppElement As Dword             ' // Reference to the element
   Local IID_IHTMLDocument3 As Guid     ' // IHTMLDocument3 interface identifier
   Local pvar As Variant                ' // General purpose variant

   IID_IHTMLDocument3 = Guid$("{3050F485-98B5-11CF-BB82-00AA00BDCE0B}")
   ' // Get a reference to the IHTMLDocument3 interface
   ppDoc3 = HtmlQueryInterface(pthis, IID_IHTMLDocument3)
   If ppDoc3 Then
      ' // Get a reference to the input element
      ppElement = IHTMLDocument3_getElementById(ppDoc3, strId)
      If ppElement Then
         ' // Get the value
         IHTMLElement_getAttribute ppElement, "value", 0, pvar
         ' // Release the element interface
         HtmlRelease ppElement
      End If
      ' // Release the IHTMLDocument3 interface
      HtmlRelease ppDoc3
   End If

   If VariantVT(pvar) = %VT_Bool Then
      Function = LTrim$(Str$(CInt(Variant#(pvar))))
   ElseIf VariantVT(pvar) = %VT_BStr Then
      Function = Variant$(pvar)
   Else
      Function = LTrim$(Str$(Variant#(pvar)))
   End If

End Function
' ****************************************************************************************

' ****************************************************************************************
' HTMLDocument_SetElementValueById
' Parameters:
' - pthis = Reference to the IHTMLDocument interface
' - strId = The value of the ID attribute
' - varValue = Variant that specifies the string, number, or Boolean to assign to the attribute.
' HtmlResult will be filled with %S_OK if successful, or an error value otherwise.
' ****************************************************************************************
Sub HTMLDocument_SetElementValueById (ByVal pthis As Dword, ByVal strId As String, ByVal varValue As Variant)

   Local ppDoc3 As Dword                ' // Reference to the IHTMLDocument3 interface
   Local ppElement As Dword             ' // Reference to the element
   Local IID_IHTMLDocument3 As Guid     ' // IHTMLDocument3 interface identifier

   IID_IHTMLDocument3 = Guid$("{3050F485-98B5-11CF-BB82-00AA00BDCE0B}")
   ' // Get a reference to the IHTMLDocument3 interface
   ppDoc3 = HtmlQueryInterface(pthis, IID_IHTMLDocument3)
   If ppDoc3 Then
      ' // Get a reference to the input element
      ppElement = IHTMLDocument3_getElementById(ppDoc3, strId)
      If ppElement Then
         ' // Set the value
         IHTMLElement_setAttribute ppElement, "value", varValue, 0
         ' // Release the element interface
         HtmlRelease ppElement
      End If
      ' // Release the IHTMLDocument3 interface
      HtmlRelease ppDoc3
   End If

End Sub
' ****************************************************************************************

' ****************************************************************************************
' HTMLDocument_GetElementInnerHtmlById
' Parameters:
' - pthis = Reference to the IHTMLDocument interface
' - strId = The value of the ID attribute
' HtmlResult will be filled with %S_OK if successful, or an error value otherwise.
' ****************************************************************************************
Function HTMLDocument_GetElementInnerHtmlById (ByVal pthis As Dword, ByVal strId As String) As String

   Local ppDoc3 As Dword                ' // Reference to the IHTMLDocument3 interface
   Local ppElement As Dword             ' // Reference to the element
   Local IID_IHTMLDocument3 As Guid     ' // IHTMLDocument3 interface identifier
   Local strHtml As String              ' // General purpose variable

   IID_IHTMLDocument3 = Guid$("{3050F485-98B5-11CF-BB82-00AA00BDCE0B}")
   ' // Get a reference to the IHTMLDocument3 interface
   ppDoc3 = HtmlQueryInterface(pthis, IID_IHTMLDocument3)
   If ppDoc3 Then
      ' // Get a reference to the input element
      ppElement = IHTMLDocument3_getElementById(ppDoc3, strId)
      If ppElement Then
         ' // Get the inner html text
         strHtml = IHTMLElement_get_innerHTML(ppElement)
         Function = strHtml
         ' // Release the element interface
         HtmlRelease ppElement
      End If
      ' // Release the IHTMLDocument3 interface
      HtmlRelease ppDoc3
   End If

End Function
' ****************************************************************************************

' ****************************************************************************************
' HTMLDocument_SetElementInnerHtmlById
' Parameters:
' - pthis = Reference to the IHTMLDocument interface
' - strId = The value of the ID attribute
' HtmlResult will be filled with %S_OK if successful, or an error value otherwise.
' ****************************************************************************************
Sub HTMLDocument_SetElementInnerHtmlById (ByVal pthis As Dword, ByVal strId As String, ByVal strHtml As String)

   Local ppDoc3 As Dword                ' // Reference to the IHTMLDocument3 interface
   Local ppElement As Dword             ' // Reference to the element
   Local IID_IHTMLDocument3 As Guid     ' // IHTMLDocument3 interface identifier
   Local pvar As Variant                ' // General purpose variant

   IID_IHTMLDocument3 = Guid$("{3050F485-98B5-11CF-BB82-00AA00BDCE0B}")
   ' // Get a reference to the IHTMLDocument3 interface
   ppDoc3 = HtmlQueryInterface(pthis, IID_IHTMLDocument3)
   If ppDoc3 Then
      ' // Get a reference to the input element
      ppElement = IHTMLDocument3_getElementById(ppDoc3, strId)
      If ppElement Then
         ' // Set the inner html text
         IHTMLElement_put_innerHTML ppElement, strHtml
         ' // Release the element interface
         HtmlRelease ppElement
      End If
      ' // Release the IHTMLDocument3 interface
      HtmlRelease ppDoc3
   End If

End Sub
' ****************************************************************************************

' ****************************************************************************************
' [get_]activeElement property
' Retrieves the object that has the focus when the parent document has focus.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_get_activeElement (ByVal pthis As Dword Ptr, ByRef p As Dword) As Long
' ****************************************************************************************
Function IHTMLDocument2_get_activeElement (ByVal pthis As Dword Ptr) As Dword
    Local p As Dword
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[10] Using Proto_IHTMLDocument2_get_activeElement(pthis, p) To HtmlResult
    Function = p
End Function
' ****************************************************************************************

' ****************************************************************************************
' Retrieves the ID of the active element (the object that has the focus when the parent
' document has focus).
' pthis = Reference to the IHTMLDocument interface.
' ****************************************************************************************
Function HTMLDocument_GetActiveElementId (ByVal pthis As Dword Ptr) As String
   Local ppElement As Dword
   ppElement = IHTMLDocument2_get_activeElement(pthis)
   Function = IHTMLElement_get_id(ppElement)
   HtmlRelease ppElement
End Function
' ****************************************************************************************

' ****************************************************************************************
' [get_]readyState property
' Retrieves a value that indicates the current state of the object.
' Possible values:
' uninitialized  Object is not initialized with data.
' loading        Object is loading its data.
' loaded         Object has finished loading its data.
' interactive    User can interact with the object even though it is not fully loaded.
' complete       Object is completely initialized.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_get_readyState (ByVal pthis As Dword Ptr, ByRef p As String) As Long
' ****************************************************************************************
Function IHTMLDocument2_get_readyState (ByVal pthis As Dword Ptr) As String
    Local p As String
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[22] Using Proto_IHTMLDocument2_get_readyState(pthis, p) To HtmlResult
    Function = ACode$(p)
End Function
' ****************************************************************************************

' ****************************************************************************************
' click method
' Simulates a click by causing the onclick event to fire.
' ****************************************************************************************
Declare Function Proto_IHTMLElement_click (ByVal pthis As Dword Ptr) As Long
' ****************************************************************************************
Sub IHTMLElement_click (ByVal pthis As Dword Ptr)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[69] Using Proto_IHTMLElement_click (pthis) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' elementFromPoint method
' Returns the element for the specified x and y coordinates.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_elementFromPoint (ByVal pthis As Dword Ptr, ByVal x As Long, ByVal y As Long, ByRef elementHit As Dword) As Long
' ****************************************************************************************
Function IHTMLDocument2_elementFromPoint (ByVal pthis As Dword Ptr, ByVal x As Long, ByVal y As Long) As Dword
    Local elementHit As Dword
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[107] Using Proto_IHTMLDocument2_elementFromPoint(pthis, x, y, elementHit) To HtmlResult
    Function = elementHit
End Function
' ****************************************************************************************

' ****************************************************************************************
' focus method
' Causes the element to receive the focus and executes the code specified by the onfocus event.
' ****************************************************************************************
Declare Function Proto_IHTMLElement2_focus (ByVal pthis As Dword Ptr) As Long
' ****************************************************************************************
Sub IHTMLElement2_focus (ByVal pthis As Dword Ptr)
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Sub
    Call Dword @@pthis[50] Using Proto_IHTMLElement2_focus (pthis) To HtmlResult
End Sub
' ****************************************************************************************

' ****************************************************************************************
' Sets the focus in the specified element.
' pthis = Reference to the IHTMLDocument interface.
' strId = Udentifier of the element.
' ****************************************************************************************
Sub HTMLDocument_SetElementFocusById (ByVal pthis As Dword, ByVal strId As String)

   Local ppDoc3 As Dword                ' // Reference to the IHTMLDocument3 interface
   Local ppElement As Dword             ' // Reference to the element
   Local ppElement2 As Dword            ' // Reference to the element
   Local IID_IHTMLDocument3 As Guid     ' // IHTMLDocument3 interface identifier
   Local IID_IHTMLElement2 As Guid      ' // IHTMLElement2 interface identifier

   IID_IHTMLDocument3 = Guid$("{3050F485-98B5-11CF-BB82-00AA00BDCE0B}")
   IID_IHTMLElement2 = Guid$("{3050F434-98B5-11CF-BB82-00AA00BDCE0B}")
   ' // Get a reference to the IHTMLDocument3 interface
   ppDoc3 = HtmlQueryInterface(pthis, IID_IHTMLDocument3)
   If ppDoc3 Then
      ' // Get a reference to the input element
      ppElement = IHTMLDocument3_getElementById(ppDoc3, strId)
      If ppElement Then
         ' // Get a reference to the IHTMLElement2 interface
         ppElement2 = HtmlQueryInterface(ppElement, IID_IHTMLElement2)
         If ppElement2 Then
            ' // Set the focus in the element
            IHTMLElement2_focus ppElement2
            ' // Release the element interface
            HtmlRelease ppElement2
         End If
         ' // Release the element interface
         HtmlRelease ppElement
      End If
      ' // Release the IHTMLDocument3 interface
      HtmlRelease ppDoc3
   End If

End Sub
' ****************************************************************************************

' ****************************************************************************************
' [get_]parentWindow property
' Retrieves a reference to the container object of the window.
' ****************************************************************************************
Declare Function Proto_IHTMLDocument2_get_parentWindow (ByVal pthis As Dword Ptr, ByRef p As Dword) As Long
' ****************************************************************************************
Function IHTMLDocument2_get_parentWindow (ByVal pthis As Dword Ptr) Export As Dword
    Local p As Dword
    If IsFalse pthis Then HtmlResult = %E_POINTER : Exit Function
    Call Dword @@pthis[108] Using Proto_IHTMLDocument2_get_parentWindow(pthis, p) To HtmlResult
    Function = p
End Function
' ****************************************************************************************

' ========================================================================================
' Identifiers
' ========================================================================================
' Form1
%IDD_FORM1                                  = 100
%IDC_FORM1_STATUSBAR1                       = 101
%IDC_FORM1_REBAR1                           = 102
%IDC_FORM1_WEBBROWSER1                      = 103
%IDC_FORM1_TOOLBAR1                         = 104
%IDC_FORM1_EDITURL                          = 105
%IDC_FORM1_GOBTN                            = 106

' Rebar1
%IDS_STRING0                                = 32770
%IDS_STRING1                                = 32771
%IDS_STRING2                                = 32772

' Command
%IDM_GOBACK                                 = 28000
%IDM_GOFORWARD                              = 28001
%IDM_FIND                                   = 28002
%IDM_PRINTPREVIEW                           = 28003
%IDM_PRINT                                  = 28004
%IDM_PROPERTIES                             = 28005
%IDM_FILE_SAVE                              = 28006
%IDM_PAGESETUP                              = 28007

' ========================================================================================
' Globals
' ========================================================================================
Global  ghInstance              As Dword    ' handle of the application instance

Global  gdwADM_ALIGNCONTROLS    As Dword    ' identifier of registered message
' Purpose: sent to a form or panel to reposition controls with alignment
'          styles after the form or panel has been resized or scrolled.
' wParam:  N/A
' lParam:  the low-order word is the width, and the high-order word the height of the client area
' Return:  N/A

Global  gdwADM_REALIGNPARTS     As Dword    ' identifier of registered message
' Purpose: posted by the parent of a status bar control to realign
'          the status bar panels.
' wParam:  handle of parent of statusbar
' lParam:  handle of statusbar
' Return:  N/A
Global  gdwCookie               As Dword    ' events cookie
' ========================================================================================

' ========================================================================================
' PROCEDURE: phnxAdjustWindowRect
' PURPOSE:   Adjusts the bounding rectangle of a nonresizeable window, based
'            on the desired size of the client area, when a system parameter
'            changes.
' ========================================================================================
Function phnxAdjustWindowRect _
  ( _
  ByVal hWnd      As Dword, _ ' window handle
  ByVal cxClient  As Long, _  ' desired width of client area in pixels
  ByVal cyClient  As Long _   ' desired height of client area in pixels
  ) As Long

  Local trc     As RECT
  Local trcTemp As RECT
  Local hMenu   As Dword
  Local dwStyle As Dword
  Local cx      As Long
  Local cy      As Long

  ' Calculate the height of the window taking menu wrap into account
  trc.nLeft   = 0
  trc.nTop    = 0
  trc.nRight  = cxClient
  trc.nBottom = cyClient
  hMenu   = GetMenu(hWnd)
  dwStyle = GetWindowLong(hWnd, %GWL_STYLE)
  AdjustWindowRectEx trc, dwStyle, (hMenu <> %NULL), GetWindowLong(hWnd, %GWL_EXSTYLE)
  ' If there is a menu, check how much wrapping occurs when we set the window
  ' to the width specified by AdjustWindowRect and an infinite amount of height.
  ' An infinite height allows us to see every single menu wrap.
  If IsTrue hMenu Then
    trcTemp = trc
    trcTemp.nBottom = &H7FFF  ' "Infinite" height
    SendMessage hWnd, %WM_NCCALCSIZE, %FALSE, ByVal VarPtr(trcTemp)
    ' Adjust our previous calculation to compensate for menu wrapping.
    trc.nBottom = trc.nBottom + trcTemp.nTop
  End If
  ' AdjustWindowRectEx does not take the standard scrollbars into account
  If (dwStyle And %WS_HSCROLL) = %WS_HSCROLL Then
    trc.nBottom = trc.nBottom + GetSystemMetrics(%SM_CYHSCROLL)
  End If
  If (dwStyle And %WS_VSCROLL) = %WS_VSCROLL Then
    trc.nRight = trc.nRight + GetSystemMetrics(%SM_CXVSCROLL)
  End If
  cx = trc.nRight - trc.nLeft
  cy = trc.nBottom - trc.nTop
  SetWindowPos hWnd, %NULL, 0, 0, cx, cy, %SWP_NOZORDER Or %SWP_NOMOVE Or %SWP_NOACTIVATE

End Function

' ========================================================================================
' PROCEDURE: phnxCenterWindow
' PURPOSE:   Centers one window over another.  It also ensures that the
'            placement is within the 'working area', meaning that it is
'            both within the display limits of the screen, -and- not
'            obscured by the tray or other frameing elements of the
'            desktop.
' ========================================================================================
Function phnxCenterWindow _
  ( _
  ByVal hWndChild   As Dword, _ ' handle of window to center
  ByVal hWndParent  As Dword _  ' handle of reference window or NULL if window is the screen
  ) As Long

  Local trcChild      As RECT     ' Child window dimensions
  Local trcParent     As RECT     ' Parent window dimensions
  Local trcWorkArea   As RECT     ' Work area dimensions
  Local tpt           As POINTAPI ' x and y coordinate of centered window
  Local cxChild       As Long     ' Width of child window
  Local cyChild       As Long     ' Height of child window
  Local cxParent      As Long     ' Width of parent window
  Local cyParent      As Long     ' Height of parent window
  Local fResult       As Long     ' Return flag for SystemParametersInfo()

  ' Get the Height and Width of the child window
  GetWindowRect hWndChild, trcChild
  cxChild = trcChild.nRight - trcChild.nLeft
  cyChild = trcChild.nBottom - trcChild.nTop

  ' Get the limits of the 'workarea'
  fResult = SystemParametersInfo(%SPI_GETWORKAREA, SizeOf(trcWorkArea), ByVal VarPtr(trcWorkArea), 0)
  If IsFalse(fResult) Then
    trcWorkArea.nLeft   = 0
    trcWorkArea.nTop    = 0
    trcWorkArea.nRight  = GetSystemMetrics(%SM_CXSCREEN)
    trcWorkArea.nBottom = GetSystemMetrics(%SM_CYSCREEN)
  End If

  ' Get the Height and Width of the parent window
  If IsTrue hWndParent Then
    GetWindowRect hWndParent, trcParent
  Else
    trcParent.nLeft   = trcWorkArea.nLeft
    trcParent.nTop    = trcWorkArea.nTop
    trcParent.nRight  = trcWorkArea.nRight
    trcParent.nBottom = trcWorkArea.nBottom
  End If
  cxParent = trcParent.nRight - trcParent.nLeft
  cyParent = trcParent.nBottom - trcParent.nTop

  ' Calculate new X position, then adjust for workarea
  tpt.x = trcParent.nLeft + ((cxParent - cxChild) \ 2)
  If (tpt.x < trcWorkArea.nLeft) Then
    tpt.x = trcWorkArea.nLeft
    ElseIf ((tpt.x + cxChild) > trcWorkArea.nRight) Then
      tpt.x = trcWorkArea.nRight - cxChild
  End If

  ' Calculate new Y position, then adjust for workarea
  tpt.y = trcParent.nTop  + ((cyParent - cyChild) \ 2)
  If (tpt.y < trcWorkArea.nTop) Then
    tpt.y = trcWorkArea.nTop
    ElseIf ((tpt.y + cyChild) > trcWorkArea.nBottom) Then
      tpt.y = trcWorkArea.nBottom - cyChild
  End If

  If (GetWindowLong(hWndChild, %GWL_STYLE) And %WS_CHILD) = %WS_CHILD Then
    ScreenToClient hWndParent, tpt
  End If

  ' Reposition the window
  Function = SetWindowPos(hWndChild, %NULL, tpt.x, tpt.y, 0, 0, %SWP_NOSIZE Or %SWP_NOZORDER)

End Function

' ========================================================================================
' FUNCTION: phnxGetFormHandle
' PURPOSE:  Finds the handle of the top-level window or MDI child
'           window that is the ancestor of the specified window.  The
'           reference handle is the handle of any control on the form.
' RETURNS:  The handle of the form.
' ========================================================================================

Function phnxGetFormHandle _
  ( _
  ByVal hWnd  As Dword _  ' reference handle
  ) As Dword

  While IsTrue (GetWindowLong(hWnd, %GWL_STYLE) And %WS_CHILD)
    If IsTrue (GetWindowLong(hWnd, %GWL_EXSTYLE) And %WS_EX_MDICHILD) Then Exit Loop
    hWnd = GetParent(hWnd)
  Wend

  Function = hWnd

End Function

' ========================================================================================
' PROCEDURE: RealignStatusPanels
' PURPOSE:   Realigns the panels and embedded controls of the specified
'            statusbar when the control is resized.
' ========================================================================================

Function RealignStatusPanels _
  ( _
  ByVal hWndParent  As Dword, _ ' handle of original parent
  ByVal hWndStatus  As Dword, _ ' handle of statusbar
  ByVal lOffsetPart As Long _   ' TRUE = offset last panel from size grip
  ) As Long

  Local trc           As RECT
  Local plEdge        As Long Ptr             ' address of array of right edges
  Local plInfo        As Long Ptr
  Local hWndChild     As Dword                ' handle of child window
  Local lNumParts     As Long
  Local lPartIdx      As Long
  Local dx            As Long
  Dim   cxBorder(2)   As Long

  ' Allocate memory for the coordinate of the right edge of each panel
  plEdge = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, 256 * 4)
  If IsTrue plEdge Then
    lNumParts = SendMessage(hWndStatus, %SB_GETPARTS, 0, ByVal 0)
    If lNumParts > 0 Then
      ' Get the right edge of each panel
      SendMessage hWndStatus, %SB_GETPARTS, lNumParts, ByVal plEdge
      ' Get the spacing between panel
      ' The inter-panel spacing is in cxBorder(2)
      SendMessage hWndStatus, %SB_GETBORDERS, 0, ByVal VarPtr(cxBorder(0))
      ' Calculate the change in the position of the right edges
      GetClientRect hWndStatus, trc
      dx = trc.nRight - cxBorder(2) - @plEdge[lNumParts - 1]
      If IsTrue lOffsetPart Then
        If (GetWindowLong(hWndStatus, %GWL_STYLE) And %SBARS_SIZEGRIP) = %SBARS_SIZEGRIP Then
          If IsFalse IsZoomed(hWndParent) Then dx = dx - GetSystemMetrics(%SM_CXVSCROLL)
        End If
      End If
      lPartIdx = 0

      Do Until lPartIdx >= lNumParts
        @plEdge[lPartIdx] = @plEdge[lPartIdx] + dx
        Incr lPartIdx
      Loop

      SendMessage hWndStatus, %SB_SETPARTS, lNumParts, ByVal plEdge
      ' Realign embedded controls
      @plEdge[0] = hWndStatus
      @plEdge[1] = dx
      EnumChildWindows hWndStatus, CodePtr(RealignStatus_ChildEnumProc), plEdge
    End If
    ' Free memory that was allocated for the edge info
    HeapFree GetProcessHeap(), 0, ByVal plEdge
  End If

End Function

' ========================================================================================
'  TITLE: StatusBar_SetText
'   DESC: Sets the text in the specified part of a status window.
' SYNTAX: StatusBar_SetText hStatus, iPart, sText
' Parameters:
'   hStatus   - The handle of the Status Bar control.
'   iPart     - Zero-based index of the part to set. If this value is 255,
'               the status window is assumed to be a simple window having
'               only one part.
'   sText     - String that specifies the text to set.
'   uType     - Type of drawing operation. This parameter can be one of the
'               following:
'
' Value          Meaning
' -------------- ----------------------------------------------------------
' 0              The text is drawn with a border to appear lower than the plane of the window.
' SBT_NOBORDERS  The text is drawn without borders.
' SBT_POPOUT     The text is drawn with a border to appear higher than the plane of the window.
' SBT_RTLREADING Displays text using right-to-left reading order on Hebrew or Arabic systems.
'
' Return Values:
'   If the operation succeeds, the return value is TRUE.
'   If the operation fails, the return value is FALSE.
'
' Remarks:
'   The message invalidates the portion of the window that has changed, causing
'   it to display the new text when the window next receives the WM_PAINT message.

' ========================================================================================

Function StatusBar_SetText (ByVal hStatus As Dword, ByVal iPart As Dword, ByVal strText As String, Opt ByVal uType As Dword) As Long
   Function = SendMessage (hStatus, %SB_SETTEXT, iPart Or uType, ByVal StrPtr(strText))
End Function

' ========================================================================================
' IOleCommandTarget_Exec method
' Executes a specified command or displays help for a command.
' ========================================================================================
Function IOleCommandTarget_Exec (ByVal pthis As Dword Ptr, ByRef pguidCmdGroup As Guid, ByVal nCmdID As Dword, ByVal nCmdexecopt As Dword, ByRef pvaIn As Variant, ByRef pvaOut As Variant) As Long
    Local HRESULT As Long
    If pthis = 0 Then Function = %E_POINTER : Exit Function
    Call Dword @@pthis[4] Using IOleCommandTarget_Exec(pthis, pguidCmdGroup, nCmdID, nCmdexecopt, pvaIn, pvaOut) To HRESULT
    Function = HRESULT
End Function
' ========================================================================================

' ========================================================================================
' Events code iclude file
' ========================================================================================
#Include "IHTMLEventObj.inc"             ' IHTMLEventObj interface
#Include "HTMLDocumentEvents2.inc"       ' HTMLDocument events
#Include "DWebBrowserEvents2.inc"        ' WebBrowser events
' ========================================================================================

' ========================================================================================
' FUNCTION: RealignStatus_ChildEnumProc
' PURPOSE:  Enumerates all embedded controls in a statusbar.
' ========================================================================================

Function RealignStatus_ChildEnumProc _
  ( _
  ByVal hWnd    As Dword, _ ' handle of child window
  ByVal lParam  As Long _   ' address of realignment info
  ) As Long

  Local trc         As RECT
  Local plEdge      As Long Ptr
  Local hWndStatus  As Dword
  Local dx          As Long
  Local x           As Long
  Local y           As Long
  Local cy          As Long

  plEdge     = lParam
  hWndStatus = @plEdge[0]
  dx         = @plEdge[1]

  If GetParent(hWnd) = hWndStatus Then
    ' Get the bounding rectangle of the embedded control
    GetWindowRect hWnd, trc
    MapWindowPoints %NULL, hWndStatus, ByVal VarPtr(trc), 2
    x  = trc.nLeft + dx
    cy = trc.nBottom - trc.nTop
    ' Get the bounding rectangle of any panel
    SendMessage hWndStatus, %SB_GETRECT, 0, ByVal VarPtr(trc)
    y = (trc.nTop + trc.nBottom - cy) \ 2
    SetWindowPos hWnd, %NULL, x, y, 0, 0, %SWP_NOZORDER Or %SWP_NOSIZE Or %SWP_DRAWFRAME
  End If

  Function = %TRUE

End Function


' ========================================================================================
' PROCEDURE: Form1_InitWindow
' PURPOSE:   Initializes main window of this application instance.
' RETURN:    FALSE if initialization was successful, TRUE to close the window on
'            failure.
' ========================================================================================

Function Form1_InitWindow _
  ( _
  ByVal hWnd    As Dword, _ ' handle of main window
  ByVal lParam  As Long _   ' address of command line
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_TranslateMessage
' PURPOSE:   Preprocesses messages.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_TranslateMessage _
  ( _
  ByVal hWnd  As Dword, _   ' handle of window
        tmsg  As tagMsg _   ' message information
  ) As Long

  ' Retrieve the handle of the window that hosts the WebBrowser control
  Local hCtrl As Dword
  hCtrl = GetDlgItem(hWnd, %IDC_FORM1_WEBBROWSER1)
  ' Retrieve the ancestor of the control that has the focus
  Local hWndCtrl As Dword
  hWndCtrl = GetFocus
  Do
     If IsFalse GetParent(hWndCtrl) Or GetParent(hWndCtrl) = hWnd Then Exit Do
     hWndCtrl = GetParent(hWndCtrl)
  Loop
' %WM_FORWARDMSG = &H37F
' If the focus is in the WebBrowser, forward the message to it
'  IF hCtrl = GetParent(GetParent(GetParent(GetFocus))) THEN
  If hCtrl = hWndCtrl Then
     If IsTrue SendMessage(hCtrl, &H37F, 0, VarPtr(tmsg)) Then Function = %TRUE
  End If

End Function

' ========================================================================================
' PROCEDURE: Form1_OnClose
' PURPOSE:   Form1 WM_CLOSE message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnClose _
  ( _
  ByVal hWnd  As Dword _  ' window handle
  ) As Long




End Function

' ========================================================================================
' PROCEDURE: Form1_OnCreate
' PURPOSE:   Form1 WM_CREATE message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnCreate _
  ( _
  ByVal hWnd        As Dword, _ ' window handle
  ByVal lptcs       As Dword, _ ' address of CREATESTRUCT structure
        lMsgResult  As Long _   ' value returned to message
  ) As Long

  Local hr As Long
  Local hCtrl As Dword
  Local ppvObj As Dword
  Local dwCookie As Dword
  Local ppDoc As Dword
  Local vUrl As Variant
  Local vScript As String
  Local s As String

  ' Get the handle of the window that hosts the webbrowser
  hCtrl = GetDlgItem(hWnd, %IDC_FORM1_WEBBROWSER1)
  If IsFalse hCtrl Then Exit Function
  ' Get the IDispatch of the control
  ppvObj = WbGetInterfacePointer(hCtrl)
  If IsFalse ppvObj Then Exit Function
  ' Connect to the events fired by the control
  hr = DWebBrowserEvents2_ConnectEvents(ppvObj, dwCookie)
  ' Store the cookie in the control properties
  SetProp hCtrl, "COOKIE", dwCookie
'  ' Call the GoHome method
'  IWebBrowser2_GoHome ppvObj
  ' Call the Navigate2 method
  vUrl = "about:blank"
  IWebBrowser2_Navigate2 ppvObj, vUrl

  ' Make an Html form
  s = "<html>" & $CrLf
  s = s & "<head>" & $CrLf
  s = s & "  <title>WebGui</title>" & $CrLf
  s = s & "" & $CrLf
  s = s & "<style type=""text/css"">" & $CrLf
  s = s & "<!--" & $CrLf
  s = s & "" & $CrLf
  s = s & "#output" & $CrLf
  s = s & "{" & $CrLf
  s = s & "background: #FFFFCC;" & $CrLf
  s = s & "border: thin solid black;" & $CrLf
  s = s & "text-align: center;" & $CrLf
  s = s & "width: 300px;" & $CrLf
  s = s & "}" & $CrLf
  s = s & "-->" & $CrLf
  s = s & "</style>" & $CrLf
  s = s & "" & $CrLf
  s = s & "</head>" & $CrLf
  s = s & "<body>" & $CrLf
  s = s & "<input type =""Button"" id=""Button_1"" name=""Button_1"" value=""Button 1""><br />" & $CrLf
  s = s & "<input type =""Button"" id=""Button_2"" name=""Button_2"" value=""Button 2""><br />" & $CrLf
  s = s & "<input type =""Button"" id=""Button_3"" name=""Button_3"" value=""Button 3""><br />" & $CrLf
  s = s & "<input type =""Button"" id=""Button_4"" name=""Button_4"" value=""Button 4""><br />" & $CrLf
  s = s & "<br />" & $CrLf
  s = s & "<div id=""output"">" & $CrLf
  s = s & "Click a button" & $CrLf
  s = s & "</div>" & $CrLf
  s = s & "<br />" & $CrLf
  s = s & "<br />" & $CrLf
  s = s & "<input type=""Text"" id=""Input_Text"" name=""Input_Text"" value="""" size=40><br />" & $CrLf
  s = s & "<br />" & $CrLf
  s = s & "<input type =""Button"" id=""Button_GetText"" name=""Button_GetTex"" value=""Get text""><br />" & $CrLf
  s = s & "</body>" & $CrLf
  s = s & "</html>" & $CrLf

  ppDoc = IWebBrowser2_GetDocument(ppvObj)
  If ppDoc Then
     IHTMLDocument2_write ppDoc, s
     IHtmlDocument2_close ppDoc
     WbRelease ppDoc
  End If

  ' Release the interface
  WbRelease ppvObj

End Function

' ========================================================================================
' PROCEDURE: Form1_OnDestroy
' PURPOSE:   Form1 WM_DESTROY message handler.
' ========================================================================================

Sub Form1_OnDestroy _
  ( _
  ByVal hWnd        As Dword, _ ' window handle
        lMsgResult  As Long _   ' value returned to message
  )

  Local hr As Long
  Local hCtrl As Dword
  Local ppvObj As Dword
  Local dwCookie As Dword

  ' Get the handle of the window that hosts the webbrowser
  hCtrl = GetDlgItem(hWnd, %IDC_FORM1_WEBBROWSER1)
  If IsFalse hCtrl Then Exit Sub
  ' Get the IDispatch of the control
  ppvObj = WbGetInterfacePointer(hCtrl)
  If IsFalse ppvObj Then Exit Sub
  ' Retrieve the events cookie
  dwCookie = GetProp(hCtrl, "COOKIE")
  ' Disconnect events
  If dwCookie Then hr = DWebBrowserEvents2_DisconnectEvents(ppvObj, dwCookie)
  ' Remove the cookie from the control
  RemoveProp hCtrl, "COOKIE"
  ' Release the interface
  WbRelease ppvObj

End Sub

' ========================================================================================
' PROCEDURE: Form1_OnQueryEndSession
' PURPOSE:   Form1 WM_QUERYENDSESSION message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnQueryEndSession _
  ( _
  ByVal hWnd        As Dword, _ ' window handle
  ByVal lSource     As Long, _  ' source of end-session request
  ByVal fLogOff     As Long, _  ' logoff flag
        lMsgResult  As Long _   ' value returned to message
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_OnSize
' PURPOSE:   Form1 WM_SIZE message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnSize _
  ( _
  ByVal hWnd      As Dword, _ ' window handle
  ByVal lState    As Long, _  ' resizing state
  ByVal cxClient  As Long, _  ' width of client area
  ByVal cyClient  As Long _   ' height of client area
  ) As Long

  Local hCtrl As Dword
  Local rc As RECT
  Local sbh As Long

  ' Height of the statusbar
  hCtrl = GetDlgItem(hWnd, %IDC_FORM1_STATUSBAR1)
  GetClientRect hCtrl, rc
  sbh = rc.nBottom - rc.nTop

  hCtrl = GetDlgItem(hWnd, %IDC_FORM1_WEBBROWSER1)
  MoveWindow hCtrl, 0, 0, cxClient, cyClient - sbh, %TRUE

End Function

' ========================================================================================
' PROCEDURE: Form1_OnPaint
' PURPOSE:   Form1 WM_PAINT message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnPaint _
  ( _
  ByVal hWnd  As Dword _  ' window handle
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_OnCommand
' PURPOSE:   Form1 WM_COMMAND message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnCommand _
  ( _
  ByVal hWnd        As Dword, _ ' window handle
  ByVal lCtrlId     As Long, _  ' identifier of menu item, control, or accelerator
  ByVal hWndCtrl    As Dword, _ ' handle of control
  ByVal lNotifyCode As Long _   ' notification code
  ) As Long

  Select Case lCtrlId
'     CASE %IDCANCEL
'        ' Send a message to close the application
'        SendMessage hWnd, %WM_CLOSE, 0, 0
'        FUNCTION = %TRUE
'     CASE %IDOK
  End Select

End Function

' ========================================================================================
' PROCEDURE: Form1_OnNotify
' PURPOSE:   Form1 WM_NOTIFY message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnNotify _
  ( _
  ByVal hWnd        As Dword, _ ' window handle
  ByVal lCtrlId     As Long, _  ' control identifier
  ByVal lptnmhdr    As Dword, _ ' address of NMHDR structure
        lMsgResult  As Long _   ' value returned to message
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_OnKillFocus
' PURPOSE:   Form1 WM_KILLFOCUS message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnKillFocus _
  ( _
  ByVal hWnd          As Dword, _ ' window handle
  ByVal hWndNewFocus  As Dword _  ' handle of window receiving focus
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_OnSetFocus
' PURPOSE:   Form1 WM_SETFOCUS message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnSetFocus _
  ( _
  ByVal hWnd          As Dword, _ ' window handle
  ByVal hWndOldFocus  As Dword _  ' handle of window losing focus
  ) As Long


End Function

' ========================================================================================
' PROCEDURE: Form1_OnActivate
' PURPOSE:   Form1 WM_ACTIVATE message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnActivate _
  ( _
  ByVal hWnd          As Dword, _ ' window handle
  ByVal lState        As Long, _  ' activation state
  ByVal hWndActDeact  As Dword, _ ' handle of window being activated/deactivated
  ByVal fMinimized    As Long _   ' minimized flag
  ) As Long

End Function

' ========================================================================================
' PROCEDURE: Form1_OnSysCommand
' PURPOSE:   Form1 WM_SYSCOMMAND message handler.
' RETURN:    TRUE if message was processed, FALSE if it was not.
' ========================================================================================

Function Form1_OnSysCommand _
  ( _
  ByVal hWnd      As Dword, _ ' window handle
  ByVal lCmdType  As Long, _  ' type of system command requested
  ByVal x         As Long, _  ' horizontal postion of cursor
  ByVal y         As Long _   ' vertical position of cursor
  ) As Long

   ' If user has clicked the x button, send a WM_CLOSE message
   If (lCmdType And &HFFF0) = %SC_CLOSE Then
      SendMessage hWnd, %WM_CLOSE, 0, 0
      Function = %TRUE
   End If

End Function

' ========================================================================================
' PROCEDURE: Project1_InitApplication
' PURPOSE:   Registers window classes and loads dynamic link libraries.
' RETURN:    FALSE if initialization was successful, TRUE if it was not.
' ========================================================================================

Function Project1_InitApplication _
  ( _
  ByVal hInstance   As Dword, _       ' handle of current instance
  ByVal pszCmdLine  As Dword _        ' address of command line
  ) As Long

 ' Initializes ATL
   AtlAxWinInit

End Function

' ========================================================================================
' PROCEDURE: Project1_UnloadInstance
' PURPOSE:   Unloads dynamic link libraries and frees memory associated with
'            this instance.
' ========================================================================================

Sub Project1_UnloadInstance _
  ( _
  ByVal hInstance As Dword _  ' handle of current instance
  )

End Sub

' ========================================================================================
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
' ========================================================================================

Function WinMain _
  ( _
  ByVal hInstance     As Dword, _       ' handle of current instance
  ByVal hPrevInstance As Dword, _       ' handle of previous instance(not used in Win32)
  ByVal pszCmdLine    As Asciiz Ptr, _  ' address of command line
  ByVal nCmdShow      As Long _         ' show state of window
  ) As Long

  Local szClassName     As Asciiz * %MAX_PATH       ' class name
  Local twcx            As WNDCLASSEX               ' class information
  Local tmsg            As tagMsg                   ' message information
  Local ticc            As INIT_COMMON_CONTROLSEX   ' specifies common control classes to register
  Local hWnd            As Dword                    ' handle of main window
  Local hWndModeless    As Dword                    ' handle of the current active window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SizeOf(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CodePtr(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, ByVal %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, ByVal %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VarPtr(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If IsFalse RegisterClassEx(twcx) Then
    Function = %TRUE
    Exit Function
  End If

  ' Load the common controls library and
  ' specify the classes to register.
  ticc.dwSize = SizeOf(ticc)
  ticc.dwICC  = %ICC_BAR_CLASSES Or %ICC_COOL_CLASSES
  InitCommonControlsEx ticc

  ' Register custom messages
  gdwADM_ALIGNCONTROLS = RegisterWindowMessage("ADM_ALIGNCONTROLS")
  gdwADM_REALIGNPARTS  = RegisterWindowMessage("ADM_REALIGNPARTS")

  ' Perform extra application initialization
  If IsTrue Project1_InitApplication(hInstance, ByVal pszCmdLine) Then
    Function = %FALSE
    Exit Function
  End If

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_EX_WINDOWEDGE, _                                          ' extended styles
                        "Form1_Class", _                                              ' class name
                        "WebGui example", _                                           ' caption
                        %WS_OVERLAPPEDWINDOW Or %WS_VISIBLE, _                        ' window styles
                        1, 100, _                                                     ' left, top
                        500, 350, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, ByVal %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If IsFalse hWnd Then
    Function = %FALSE
    Exit Function
  End If

  ' Adjust the size of the window so that it conforms
  ' to the specified size of the client area
  phnxAdjustWindowRect hWnd, 500, 350

  ' Initialize this instance of the window
  If IsTrue Form1_InitWindow(hWnd, ByVal pszCmdLine) Then
    SendMessage hWnd, %WM_CLOSE, 0, 0
    Function = %FALSE
    Exit Function
  End If

  ' Center the window relative to the screen
  phnxCenterWindow hWnd, %NULL
  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While IsTrue GetMessage(tmsg, ByVal %NULL, 0, 0)
    If IsFalse Form1_TranslateMessage(hWnd, tmsg) Then
      hWndModeless = phnxGetFormHandle(GetFocus())
      If (IsFalse hWndModeless) Or (IsFalse IsDialogMessage(hWndModeless, tmsg)) Then
        TranslateMessage tmsg
        DispatchMessage tmsg
      End If
    End If
  Wend

  ' Free memory and unload dlls associated with this instance
  Project1_UnloadInstance hInstance

  Function = tmsg.wParam

End Function

' ========================================================================================
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
' ========================================================================================

Function Form1_WndProc _
  ( _
  ByVal hWnd    As Dword, _ ' window handle
  ByVal uMsg    As Dword, _ ' type of message
  ByVal wParam  As Dword, _ ' first message parameter
  ByVal lParam  As Long _   ' second message parameter
  ) Export As Long

  Local szItem        As Asciiz * %MAX_PATH   ' working variable
  Local trbi          As REBARINFO            ' specifies attributes(imagelist) of the rebar control
  Local trbbi         As REBARBANDINFO        ' specifies or receives the attributes of a rebar band
  Local ttbb          As TBBUTTON             ' specifies or receives the attributes of a toolbar button
  Local ttbab         As TBADDBITMAP          ' specifies the images to add to a toolbar
  Local ptnmhdr       As NMHDR Ptr            ' information about a notification message
  Local ptttdi        As NMTTDISPINFO Ptr     ' tooltip notification message information
  Local pttbb         As TBBUTTON Ptr         ' address of array of toolbar button info
  Local plEdge        As Long Ptr             ' address of array of right edges
  Local hWndChild     As Dword                ' handle of child window
  Local hWndRebar     As Dword                ' handle of rebar control
  Local hFont         As Dword                ' handle of font used by form
  Local lMsgResult    As Long                 ' value returned to message after message is processed

  Select Case uMsg
    Case %WM_COMMAND

      Select Case LoWrd(wParam)

        Case Else
          ' If the message was processed
          If IsTrue Form1_OnCommand(hWnd, LoWrd(wParam), lParam, HiWrd(wParam)) Then
            Function = %FALSE
            Exit Function
          End If
      End Select

    Case %WM_SYSCOLORCHANGE
      ' Forward this message to common controls so that they will
      ' be properly updated when the user changes the color settings.
      SendMessage GetDlgItem(hWnd, %IDC_FORM1_STATUSBAR1), %WM_SYSCOLORCHANGE, wParam, lParam
      SendMessage GetDlgItem(hWndRebar, %IDC_FORM1_TOOLBAR1), %WM_SYSCOLORCHANGE, wParam, lParam

    Case %WM_ACTIVATE
      ' If the message was processed
      If IsTrue Form1_OnActivate(hWnd, LoWrd(wParam), lParam, HiWrd(wParam)) Then
        Function = %FALSE
        Exit Function
      End If
      Function = %FALSE
      Exit Function

    Case %WM_SETFOCUS
      ' If the message was processed
      If IsTrue Form1_OnSetFocus(hWnd, wParam) Then
        Function = %FALSE
        Exit Function
      End If
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    Case %WM_KILLFOCUS
      ' If the message was processed
      If IsTrue Form1_OnKillFocus(hWnd, wParam) Then
        Function = %FALSE
        Exit Function
      End If

    Case %WM_CLOSE
      ' If the message was processed
      If IsTrue Form1_OnClose(hWnd) Then
        Function = %FALSE
        Exit Function
      End If

    Case %WM_QUERYENDSESSION
      ' If the message was processed
      If IsTrue Form1_OnQueryEndSession(hWnd, wParam, lParam, lMsgResult) Then
        Function = lMsgResult
        Exit Function
      End If

    Case %WM_DESTROY
      Form1_OnDestroy hWnd, lMsgResult
      PostQuitMessage lMsgResult
      Function = %FALSE
      Exit Function

    Case %WM_SIZE
      If wParam <> %SIZE_MINIMIZED Then
        ' Update the size and position of aligned controls
        SendMessage hWnd, gdwADM_ALIGNCONTROLS, wParam, lParam
        ' Realign statusbar panels
        PostMessage hWnd, gdwADM_REALIGNPARTS, hWnd, GetDlgItem(hWnd, %IDC_FORM1_STATUSBAR1)
        ' If the message was processed
        If IsTrue Form1_OnSize(hWnd, wParam, LoWrd(lParam), HiWrd(lParam)) Then
          Function = %FALSE
          Exit Function
        End If
        Function = %FALSE
        Exit Function
      End If

    Case gdwADM_ALIGNCONTROLS
      ' Update the size and position of aligned controls
      hWndChild = GetDlgItem(hWnd, %IDC_FORM1_STATUSBAR1)
      SendMessage hWndChild, %WM_SIZE, wParam, lParam
      InvalidateRect hWndChild, ByVal %NULL, %TRUE
      SendMessage GetDlgItem(hWnd, %IDC_FORM1_REBAR1), %WM_SIZE, wParam, lParam
      Function = %FALSE
      Exit Function

    Case gdwADM_REALIGNPARTS
      ' Realign the panels of statusbars
      RealignStatusPanels wParam, lParam, %TRUE
      InvalidateRect lParam, ByVal %NULL, %TRUE
      Function = %FALSE
      Exit Function

    Case %WM_PAINT
      ' If the message was processed
      If IsTrue Form1_OnPaint(hWnd) Then
        Function = %FALSE
        Exit Function
      End If

    Case %WM_SYSCOMMAND
      ' If the message was processed
      If IsTrue Form1_OnSysCommand(hWnd, wParam, LoInt(lParam), HiInt(lParam)) Then
        Function = %FALSE
        Exit Function
      End If

    Case %WM_CREATE
      ' Create font used by container
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the Statusbar1 statusbar control
      hWndChild = CreateWindowEx(%NULL, _                                             ' extended styles
                                 "msctls_statusbar32", _                              ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD Or %WS_VISIBLE Or _                        ' window styles
                                 %CCS_BOTTOM Or %SBARS_SIZEGRIP, _                    ' class styles
                                 0, 347, _                                            ' left, top
                                 535, 23, _                                           ' width, height
                                 hWnd, %IDC_FORM1_STATUSBAR1, _                       ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Allocate memory for the coordinate of the right edge of each part
      plEdge = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, 1 * 4)
      If IsTrue plEdge Then
        @plEdge[0] = 96
        SendMessage hWndChild, %SB_SETPARTS, 1, ByVal plEdge
        ' Free memory that was allocated for the edge info
        HeapFree GetProcessHeap(), 0, ByVal plEdge
      End If
      ' Update the size of the statusbar
      SendMessage hWndChild, %WM_SIZE, 0, 0

      ' Create the WebBrowser control
      hWndChild = CreateWindowEx(%NULL, _                                             ' extended styles
                                 "AtlAxWin", _                                        ' class name
                                 "Shell.Explorer", _                                  ' caption
                                 %WS_CHILD Or %WS_VISIBLE Or %WS_CLIPSIBLINGS Or _    ' window styles
                                 %WS_TABSTOP, _
                                 0, 0, _                                              ' left, top
                                 0, 0, _                                              ' width, height
                                 hWnd, %IDC_FORM1_WEBBROWSER1, _                      ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters

      ' If the message was processed
      If IsTrue Form1_OnCreate(hWnd, lParam, lMsgResult) Then
        Function = lMsgResult
        Exit Function
      End If
      Function = %FALSE
      Exit Function
  End Select

  Function = DefWindowProc(hWnd, uMsg, wParam, lParam)

End Function
' ========================================================================================
